# IO.Swagger - the C# library for the E2E.pt API

REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>

This C# SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.24.3
- SDK version: 1.0.0
- Build package: io.swagger.codegen.languages.CSharpClientCodegen

<a name="frameworks-supported"></a>
## Frameworks supported
- .NET 4.0 or later
- Windows Phone 7.1 (Mango)

<a name="dependencies"></a>
## Dependencies
- [RestSharp](https://www.nuget.org/packages/RestSharp) - 105.1.0 or later
- [Json.NET](https://www.nuget.org/packages/Newtonsoft.Json/) - 7.0.0 or later
- [JsonSubTypes](https://www.nuget.org/packages/JsonSubTypes/) - 1.2.0 or later

The DLLs included in the package may not be the latest version. We recommend using [NuGet](https://docs.nuget.org/consume/installing-nuget) to obtain the latest version of the packages:
```
Install-Package RestSharp
Install-Package Newtonsoft.Json
Install-Package JsonSubTypes
```

NOTE: RestSharp versions greater than 105.1.0 have a bug which causes file uploads to fail. See [RestSharp#742](https://github.com/restsharp/RestSharp/issues/742)

<a name="installation"></a>
## Installation
Run the following command to generate the DLL
- [Mac/Linux] `/bin/sh build.sh`
- [Windows] `build.bat`

Then include the DLL (under the `bin` folder) in the C# project, and use the namespaces:
```csharp
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;
```
<a name="packaging"></a>
## Packaging

A `.nuspec` is included with the project. You can follow the Nuget quickstart to [create](https://docs.microsoft.com/en-us/nuget/quickstart/create-and-publish-a-package#create-the-package) and [publish](https://docs.microsoft.com/en-us/nuget/quickstart/create-and-publish-a-package#publish-the-package) packages.

This `.nuspec` uses placeholders from the `.csproj`, so build the `.csproj` directly:

```
nuget pack -Build -OutputDirectory out IO.Swagger.csproj
```

Then, publish to a [local feed](https://docs.microsoft.com/en-us/nuget/hosting-packages/local-feeds) or [other host](https://docs.microsoft.com/en-us/nuget/hosting-packages/overview) and consume the new package via Nuget as usual.

<a name="getting-started"></a>
## Getting Started

```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class Example
    {
        public void main()
        {

            var apiInstance = new AccountApi();
            var body = new Account(); // Account | 

            try
            {
                // Create record
                Account result = apiInstance.AccountCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AccountCreate: " + e.Message );
            }

        }
    }
}
```

<a name="documentation-for-api-endpoints"></a>
## Documentation for API Endpoints

All URIs are relative to *https://e2e.pt/ws*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccountApi* | [**AccountCreate**](docs/AccountApi.md#accountcreate) | **POST** /account | Create record
*AccountApi* | [**AccountDelete**](docs/AccountApi.md#accountdelete) | **DELETE** /account/{id} | Delete record
*AccountApi* | [**AccountId**](docs/AccountApi.md#accountid) | **GET** /account/id/{id} | Get record
*AccountApi* | [**AccountList**](docs/AccountApi.md#accountlist) | **GET** /account | List records
*AccountApi* | [**AccountUpdate**](docs/AccountApi.md#accountupdate) | **PUT** /account/{id} | Update record
*AccountApi* | [**AddressCreate**](docs/AccountApi.md#addresscreate) | **POST** /account/{accountId}/address | Create record
*AccountApi* | [**AddressDelete**](docs/AccountApi.md#addressdelete) | **DELETE** /account/{accountId}/address/{id} | Delete record
*AccountApi* | [**AddressId**](docs/AccountApi.md#addressid) | **GET** /account/{accountId}/address/id/{id} | Get record
*AccountApi* | [**AddressList**](docs/AccountApi.md#addresslist) | **GET** /account/{accountId}/address | List records
*AccountApi* | [**AddressUpdate**](docs/AccountApi.md#addressupdate) | **PUT** /account/{accountId}/address/{id} | Update record
*AccountApi* | [**ContactCreate**](docs/AccountApi.md#contactcreate) | **POST** /account/{accountId}/contact | Create record
*AccountApi* | [**ContactDelete**](docs/AccountApi.md#contactdelete) | **DELETE** /account/{accountId}/contact/{id} | Delete record
*AccountApi* | [**ContactId**](docs/AccountApi.md#contactid) | **GET** /account/{accountId}/contact/id/{id} | Get record
*AccountApi* | [**ContactList**](docs/AccountApi.md#contactlist) | **GET** /account/{accountId}/contact | List records
*AccountApi* | [**ContactTypeList**](docs/AccountApi.md#contacttypelist) | **GET** /account/contact/type | List records
*AccountApi* | [**ContactUpdate**](docs/AccountApi.md#contactupdate) | **PUT** /account/{accountId}/contact/{id} | Update record
*AccountApi* | [**CurrentAccountList**](docs/AccountApi.md#currentaccountlist) | **GET** /account/id/{id}/currentAccount | List customer or supplier current account
*DocumentApi* | [**DocumentCreate**](docs/DocumentApi.md#documentcreate) | **POST** /document | Create record
*DocumentApi* | [**DocumentDiscount**](docs/DocumentApi.md#documentdiscount) | **POST** /document/discount | Get document discount
*DocumentApi* | [**DocumentEmail**](docs/DocumentApi.md#documentemail) | **PATCH** /document/email | Send document by mail
*DocumentApi* | [**DocumentId**](docs/DocumentApi.md#documentid) | **GET** /document/id/{id} | Get record
*DocumentApi* | [**DocumentList**](docs/DocumentApi.md#documentlist) | **GET** /document | List records
*DocumentApi* | [**DocumenttypeList**](docs/DocumentApi.md#documenttypelist) | **GET** /document/type | List document types and series
*HrApi* | [**EmployeeAllFiles**](docs/HrApi.md#employeeallfiles) | **GET** /hr/employee/files | Get files
*HrApi* | [**EmployeeCreate**](docs/HrApi.md#employeecreate) | **POST** /hr/employee | Create record
*HrApi* | [**EmployeeDelete**](docs/HrApi.md#employeedelete) | **DELETE** /hr/employee/{id} | Delete record
*HrApi* | [**EmployeeFileDownloadBase64**](docs/HrApi.md#employeefiledownloadbase64) | **GET** /hr/employee/id/{id}/file/{fileId}/base64 | Get record file
*HrApi* | [**EmployeeFileDownloadBin**](docs/HrApi.md#employeefiledownloadbin) | **GET** /hr/employee/id/{id}/file/{fileId}/bin | Get record file
*HrApi* | [**EmployeeFiles**](docs/HrApi.md#employeefiles) | **GET** /hr/employee/id/{id}/file | Get record files
*HrApi* | [**EmployeeId**](docs/HrApi.md#employeeid) | **GET** /hr/employee/id/{id} | Get record
*HrApi* | [**EmployeeList**](docs/HrApi.md#employeelist) | **GET** /hr/employee | List records
*HrApi* | [**EmployeeUpdate**](docs/HrApi.md#employeeupdate) | **PUT** /hr/employee/{id} | Update record
*HrApi* | [**MonthlyPayrollSupplementCreate**](docs/HrApi.md#monthlypayrollsupplementcreate) | **POST** /hr/monthly_payroll_supplement | Create record
*HrApi* | [**MonthlyPayrollSupplementCreatePack**](docs/HrApi.md#monthlypayrollsupplementcreatepack) | **POST** /hr/monthly_payroll_supplement/pack/{packid} | Create record
*HrApi* | [**MonthlyPayrollSupplementDelete**](docs/HrApi.md#monthlypayrollsupplementdelete) | **DELETE** /hr/monthly_payroll_supplement/id/{id} | Delete record
*HrApi* | [**MonthlyPayrollSupplementDeleteExternalId**](docs/HrApi.md#monthlypayrollsupplementdeleteexternalid) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id} | Delete record
*HrApi* | [**MonthlyPayrollSupplementDeleteExternalIdPack**](docs/HrApi.md#monthlypayrollsupplementdeleteexternalidpack) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
*HrApi* | [**MonthlyPayrollSupplementDeletePack**](docs/HrApi.md#monthlypayrollsupplementdeletepack) | **DELETE** /hr/monthly_payroll_supplement/id/{id}/pack/{packid} | Delete record
*HrApi* | [**MonthlyPayrollSupplementExternalId**](docs/HrApi.md#monthlypayrollsupplementexternalid) | **GET** /hr/monthly_payroll_supplement/external/{source}/{id} | Get record
*HrApi* | [**MonthlyPayrollSupplementId**](docs/HrApi.md#monthlypayrollsupplementid) | **GET** /hr/monthly_payroll_supplement/id/{id} | Get record
*HrApi* | [**MonthlyPayrollSupplementList**](docs/HrApi.md#monthlypayrollsupplementlist) | **GET** /hr/monthly_payroll_supplement | List records
*HrApi* | [**MonthlyPayrollSupplementUpdate**](docs/HrApi.md#monthlypayrollsupplementupdate) | **PUT** /hr/monthly_payroll_supplement/{id} | Update record
*HrApi* | [**MonthlyPayrollSupplementUpdatePack**](docs/HrApi.md#monthlypayrollsupplementupdatepack) | **PUT** /hr/monthly_payroll_supplement/{id}/pack/{packid} | Update record
*HrApi* | [**PayrollSupplementCreate**](docs/HrApi.md#payrollsupplementcreate) | **POST** /hr/payroll_supplement | Create record
*HrApi* | [**PayrollSupplementCreatePack**](docs/HrApi.md#payrollsupplementcreatepack) | **POST** /hr/payroll_supplement/pack/{packid} | Create record
*HrApi* | [**PayrollSupplementDelete**](docs/HrApi.md#payrollsupplementdelete) | **DELETE** /hr/payroll_supplement/id/{id} | Delete record
*HrApi* | [**PayrollSupplementDeleteExternalId**](docs/HrApi.md#payrollsupplementdeleteexternalid) | **DELETE** /hr/payroll_supplement/external/{source}/{id} | Delete record
*HrApi* | [**PayrollSupplementDeleteExternalIdPack**](docs/HrApi.md#payrollsupplementdeleteexternalidpack) | **DELETE** /hr/payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
*HrApi* | [**PayrollSupplementDeletePack**](docs/HrApi.md#payrollsupplementdeletepack) | **DELETE** /hr/payroll_supplement/id/{id}/pack/{packid} | Delete record
*HrApi* | [**PayrollSupplementExternalId**](docs/HrApi.md#payrollsupplementexternalid) | **GET** /hr/payroll_supplement/external/{source}/{id} | Get record
*HrApi* | [**PayrollSupplementId**](docs/HrApi.md#payrollsupplementid) | **GET** /hr/payroll_supplement/id/{id} | Get record
*HrApi* | [**PayrollSupplementList**](docs/HrApi.md#payrollsupplementlist) | **GET** /hr/payroll_supplement | List records
*HrApi* | [**PayrollSupplementTypeList**](docs/HrApi.md#payrollsupplementtypelist) | **GET** /hr/payroll_supplement/payroll_supplement_type | List records
*HrApi* | [**PayrollSupplementUpdate**](docs/HrApi.md#payrollsupplementupdate) | **PUT** /hr/payroll_supplement/{id} | Update record
*HrApi* | [**PayrollSupplementUpdatePack**](docs/HrApi.md#payrollsupplementupdatepack) | **PUT** /hr/payroll_supplement/{id}/pack/{packid} | Update record
*HrApi* | [**TimeAttendanceId**](docs/HrApi.md#timeattendanceid) | **GET** /hr/time_attendance/id/{id} | Get record
*HrApi* | [**TimeAttendanceList**](docs/HrApi.md#timeattendancelist) | **GET** /hr/time_attendance | List records
*HrApi* | [**TimeExtraCreate**](docs/HrApi.md#timeextracreate) | **POST** /hr/time_extra | Create record
*HrApi* | [**TimeExtraCreatePack**](docs/HrApi.md#timeextracreatepack) | **POST** /hr/time_extra/pack/{packid} | Create record
*HrApi* | [**TimeExtraDelete**](docs/HrApi.md#timeextradelete) | **DELETE** /hr/time_extra/id/{id} | Delete record
*HrApi* | [**TimeExtraDeleteExternalId**](docs/HrApi.md#timeextradeleteexternalid) | **DELETE** /hr/time_extra/external/{source}/{id} | Delete record
*HrApi* | [**TimeExtraDeleteExternalIdPack**](docs/HrApi.md#timeextradeleteexternalidpack) | **DELETE** /hr/time_extra/external/{source}/{id}/pack/{packid} | Delete record
*HrApi* | [**TimeExtraDeletePack**](docs/HrApi.md#timeextradeletepack) | **DELETE** /hr/time_extra/id/{id}/pack/{packid} | Delete record
*HrApi* | [**TimeExtraExternalId**](docs/HrApi.md#timeextraexternalid) | **GET** /hr/time_extra/external/{source}/{id} | Get record
*HrApi* | [**TimeExtraId**](docs/HrApi.md#timeextraid) | **GET** /hr/time_extra/id/{id} | Get record
*HrApi* | [**TimeExtraList**](docs/HrApi.md#timeextralist) | **GET** /hr/time_extra | List records
*HrApi* | [**TimeExtraTypeList**](docs/HrApi.md#timeextratypelist) | **GET** /hr/time_extra/time_extra_type | List records
*HrApi* | [**TimeExtraUpdate**](docs/HrApi.md#timeextraupdate) | **PUT** /hr/time_extra/{id} | Update record
*HrApi* | [**TimeExtraUpdatePack**](docs/HrApi.md#timeextraupdatepack) | **PUT** /hr/time_extra/{id}/pack/{packid} | Update record
*HrApi* | [**TimeOffLeaveCreate**](docs/HrApi.md#timeoffleavecreate) | **POST** /hr/time_off_leave | Create record
*HrApi* | [**TimeOffLeaveDelete**](docs/HrApi.md#timeoffleavedelete) | **DELETE** /hr/time_off_leave/id/{id} | Delete record
*HrApi* | [**TimeOffLeaveDeleteExternalId**](docs/HrApi.md#timeoffleavedeleteexternalid) | **DELETE** /hr/time_off_leave/external/{source}/{id} | Delete record
*HrApi* | [**TimeOffLeaveExternalId**](docs/HrApi.md#timeoffleaveexternalid) | **GET** /hr/time_off_leave/external/{source}/{id} | Get record
*HrApi* | [**TimeOffLeaveId**](docs/HrApi.md#timeoffleaveid) | **GET** /hr/time_off_leave/id/{id} | Get record
*HrApi* | [**TimeOffLeaveList**](docs/HrApi.md#timeoffleavelist) | **GET** /hr/time_off_leave | List records
*HrApi* | [**TimeOffLeaveUpdate**](docs/HrApi.md#timeoffleaveupdate) | **PUT** /hr/time_off_leave/{id} | Update record
*HrApi* | [**TimeOffLeavetypeList**](docs/HrApi.md#timeoffleavetypelist) | **GET** /hr/time_off_leave/time_off_leave_type | List records
*ProductApi* | [**PriceList**](docs/ProductApi.md#pricelist) | **GET** /product/price | List product prices
*ProductApi* | [**PriceTypeList**](docs/ProductApi.md#pricetypelist) | **GET** /product/price/type | List product prices type
*ProductApi* | [**ProductCategoryList**](docs/ProductApi.md#productcategorylist) | **GET** /product/category | List product categories
*ProductApi* | [**ProductCreate**](docs/ProductApi.md#productcreate) | **POST** /product | Create record
*ProductApi* | [**ProductDelete**](docs/ProductApi.md#productdelete) | **DELETE** /product/{id} | Delete record
*ProductApi* | [**ProductId**](docs/ProductApi.md#productid) | **GET** /product/id/{id} | Get record
*ProductApi* | [**ProductList**](docs/ProductApi.md#productlist) | **GET** /product | List records
*ProductApi* | [**ProductUpdate**](docs/ProductApi.md#productupdate) | **PUT** /product/{id} | Update record
*ProductApi* | [**StockList**](docs/ProductApi.md#stocklist) | **GET** /product/stock | List records
*ToolsApi* | [**QuerySql**](docs/ToolsApi.md#querysql) | **POST** /tools/query | Execute SQL Command


<a name="documentation-for-models"></a>
## Documentation for Models

 - [Model.Account](docs/Account.md)
 - [Model.AccountListContainer](docs/AccountListContainer.md)
 - [Model.Address](docs/Address.md)
 - [Model.AddressListContainer](docs/AddressListContainer.md)
 - [Model.Column](docs/Column.md)
 - [Model.Contact](docs/Contact.md)
 - [Model.ContactListContainer](docs/ContactListContainer.md)
 - [Model.ContactType](docs/ContactType.md)
 - [Model.ContactTypeListContainer](docs/ContactTypeListContainer.md)
 - [Model.Country](docs/Country.md)
 - [Model.CurrentAccount](docs/CurrentAccount.md)
 - [Model.CurrentAccountListContainer](docs/CurrentAccountListContainer.md)
 - [Model.Document](docs/Document.md)
 - [Model.DocumentLine](docs/DocumentLine.md)
 - [Model.DocumentListContainer](docs/DocumentListContainer.md)
 - [Model.DocumentSerie](docs/DocumentSerie.md)
 - [Model.DocumentType](docs/DocumentType.md)
 - [Model.DocumentTypeListContainer](docs/DocumentTypeListContainer.md)
 - [Model.Employee](docs/Employee.md)
 - [Model.EmployeeListContainer](docs/EmployeeListContainer.md)
 - [Model.FileListContainer](docs/FileListContainer.md)
 - [Model.I18nText](docs/I18nText.md)
 - [Model.Lot](docs/Lot.md)
 - [Model.ModelFile](docs/ModelFile.md)
 - [Model.Pair](docs/Pair.md)
 - [Model.PaymentMethod](docs/PaymentMethod.md)
 - [Model.PaymentTerms](docs/PaymentTerms.md)
 - [Model.PayrollSupplement](docs/PayrollSupplement.md)
 - [Model.PayrollSupplementListContainer](docs/PayrollSupplementListContainer.md)
 - [Model.PayrollSupplementType](docs/PayrollSupplementType.md)
 - [Model.PayrollSupplementTypeListContainer](docs/PayrollSupplementTypeListContainer.md)
 - [Model.Price](docs/Price.md)
 - [Model.PriceListContainer](docs/PriceListContainer.md)
 - [Model.PriceType](docs/PriceType.md)
 - [Model.PriceTypeListContainer](docs/PriceTypeListContainer.md)
 - [Model.Product](docs/Product.md)
 - [Model.ProductAttribute](docs/ProductAttribute.md)
 - [Model.ProductCategory](docs/ProductCategory.md)
 - [Model.ProductCategoryListContainer](docs/ProductCategoryListContainer.md)
 - [Model.ProductFeature](docs/ProductFeature.md)
 - [Model.ProductFeatureValue](docs/ProductFeatureValue.md)
 - [Model.ProductListContainer](docs/ProductListContainer.md)
 - [Model.QueryResultDTO](docs/QueryResultDTO.md)
 - [Model.Record](docs/Record.md)
 - [Model.Salesman](docs/Salesman.md)
 - [Model.Stock](docs/Stock.md)
 - [Model.StockListContainer](docs/StockListContainer.md)
 - [Model.Tax](docs/Tax.md)
 - [Model.TaxRule](docs/TaxRule.md)
 - [Model.TaxZone](docs/TaxZone.md)
 - [Model.TimeAttendance](docs/TimeAttendance.md)
 - [Model.TimeAttendanceListContainer](docs/TimeAttendanceListContainer.md)
 - [Model.TimeExtra](docs/TimeExtra.md)
 - [Model.TimeExtraListContainer](docs/TimeExtraListContainer.md)
 - [Model.TimeExtraType](docs/TimeExtraType.md)
 - [Model.TimeExtraTypeListContainer](docs/TimeExtraTypeListContainer.md)
 - [Model.TimeOffLeave](docs/TimeOffLeave.md)
 - [Model.TimeOffLeaveListContainer](docs/TimeOffLeaveListContainer.md)
 - [Model.TimeOffLeaveType](docs/TimeOffLeaveType.md)
 - [Model.TimeOffLeaveTypeListContainer](docs/TimeOffLeaveTypeListContainer.md)
 - [Model.Unit](docs/Unit.md)
 - [Model.Warehouse](docs/Warehouse.md)


<a name="documentation-for-authorization"></a>
## Documentation for Authorization

<a name="api_key"></a>
### api_key

- **Type**: API key
- **API key parameter name**: api_key
- **Location**: HTTP header

<a name="company_key"></a>
### company_key

- **Type**: API key
- **API key parameter name**: company_key
- **Location**: HTTP header

