# IO.Swagger.Api.AccountApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**AccountCreate**](AccountApi.md#accountcreate) | **POST** /account | Create record
[**AccountDelete**](AccountApi.md#accountdelete) | **DELETE** /account/{id} | Delete record
[**AccountId**](AccountApi.md#accountid) | **GET** /account/id/{id} | Get record
[**AccountList**](AccountApi.md#accountlist) | **GET** /account | List records
[**AccountUpdate**](AccountApi.md#accountupdate) | **PUT** /account/{id} | Update record
[**AddressCreate**](AccountApi.md#addresscreate) | **POST** /account/{accountId}/address | Create record
[**AddressDelete**](AccountApi.md#addressdelete) | **DELETE** /account/{accountId}/address/{id} | Delete record
[**AddressId**](AccountApi.md#addressid) | **GET** /account/{accountId}/address/id/{id} | Get record
[**AddressList**](AccountApi.md#addresslist) | **GET** /account/{accountId}/address | List records
[**AddressUpdate**](AccountApi.md#addressupdate) | **PUT** /account/{accountId}/address/{id} | Update record
[**ContactCreate**](AccountApi.md#contactcreate) | **POST** /account/{accountId}/contact | Create record
[**ContactDelete**](AccountApi.md#contactdelete) | **DELETE** /account/{accountId}/contact/{id} | Delete record
[**ContactId**](AccountApi.md#contactid) | **GET** /account/{accountId}/contact/id/{id} | Get record
[**ContactList**](AccountApi.md#contactlist) | **GET** /account/{accountId}/contact | List records
[**ContactTypeList**](AccountApi.md#contacttypelist) | **GET** /account/contact/type | List records
[**ContactUpdate**](AccountApi.md#contactupdate) | **PUT** /account/{accountId}/contact/{id} | Update record
[**CurrentAccountList**](AccountApi.md#currentaccountlist) | **GET** /account/id/{id}/currentAccount | List customer or supplier current account


<a name="accountcreate"></a>
# **AccountCreate**
> Account AccountCreate (Account body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountCreateExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var body = new Account(); // Account | 

            try
            {
                // Create record
                Account result = apiInstance.AccountCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AccountCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Account**](Account.md)|  | 

### Return type

[**Account**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountdelete"></a>
# **AccountDelete**
> void AccountDelete (string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountDeleteExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.AccountDelete(id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AccountDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountid"></a>
# **AccountId**
> Account AccountId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountIdExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                Account result = apiInstance.AccountId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AccountId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**Account**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountlist"></a>
# **AccountList**
> AccountListContainer AccountList (int? offset = null, int? limit = null, string name = null, string vatNumber = null, string email = null, string type = null, DateTime? updateDate = null, bool? deleted = null, List<string> ids = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountListExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var name = name_example;  // string |  (optional) 
            var vatNumber = vatNumber_example;  // string |  (optional) 
            var email = email_example;  // string |  (optional) 
            var type = type_example;  // string |  (optional) 
            var updateDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var deleted = true;  // bool? |  (optional) 
            var ids = new List<string>(); // List<string> |  (optional) 
            var salesman = new List<string>(); // List<string> |  (optional) 
            var extraFieldsExpression = extraFieldsExpression_example;  // string |  (optional) 
            var extraFields = new List<string>(); // List<string> |  (optional) 

            try
            {
                // List records
                AccountListContainer result = apiInstance.AccountList(offset, limit, name, vatNumber, email, type, updateDate, deleted, ids, salesman, extraFieldsExpression, extraFields);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AccountList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **name** | **string**|  | [optional] 
 **vatNumber** | **string**|  | [optional] 
 **email** | **string**|  | [optional] 
 **type** | **string**|  | [optional] 
 **updateDate** | **DateTime?**| ISO 8601 | [optional] 
 **deleted** | **bool?**|  | [optional] 
 **ids** | [**List&lt;string&gt;**](string.md)|  | [optional] 
 **salesman** | [**List&lt;string&gt;**](string.md)|  | [optional] 
 **extraFieldsExpression** | **string**|  | [optional] 
 **extraFields** | [**List&lt;string&gt;**](string.md)|  | [optional] 

### Return type

[**AccountListContainer**](AccountListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="accountupdate"></a>
# **AccountUpdate**
> Account AccountUpdate (string id, Account body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AccountUpdateExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var id = id_example;  // string | 
            var body = new Account(); // Account | 

            try
            {
                // Update record
                Account result = apiInstance.AccountUpdate(id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AccountUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **body** | [**Account**](Account.md)|  | 

### Return type

[**Account**](Account.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="addresscreate"></a>
# **AddressCreate**
> Address AddressCreate (string accountId, Address body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AddressCreateExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var body = new Address(); // Address | 

            try
            {
                // Create record
                Address result = apiInstance.AddressCreate(accountId, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AddressCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **body** | [**Address**](Address.md)|  | 

### Return type

[**Address**](Address.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="addressdelete"></a>
# **AddressDelete**
> void AddressDelete (string accountId, string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AddressDeleteExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.AddressDelete(accountId, id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AddressDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="addressid"></a>
# **AddressId**
> Address AddressId (string accountId, string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AddressIdExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Get record
                Address result = apiInstance.AddressId(accountId, id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AddressId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **id** | **string**|  | 

### Return type

[**Address**](Address.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="addresslist"></a>
# **AddressList**
> AddressListContainer AddressList (string accountId, int? offset = null, int? limit = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AddressListExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)

            try
            {
                // List records
                AddressListContainer result = apiInstance.AddressList(accountId, offset, limit);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AddressList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]

### Return type

[**AddressListContainer**](AddressListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="addressupdate"></a>
# **AddressUpdate**
> Address AddressUpdate (string accountId, string id, Address body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class AddressUpdateExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var id = id_example;  // string | 
            var body = new Address(); // Address | 

            try
            {
                // Update record
                Address result = apiInstance.AddressUpdate(accountId, id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.AddressUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **id** | **string**|  | 
 **body** | [**Address**](Address.md)|  | 

### Return type

[**Address**](Address.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="contactcreate"></a>
# **ContactCreate**
> Contact ContactCreate (string accountId, Contact body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ContactCreateExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var body = new Contact(); // Contact | 

            try
            {
                // Create record
                Contact result = apiInstance.ContactCreate(accountId, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.ContactCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **body** | [**Contact**](Contact.md)|  | 

### Return type

[**Contact**](Contact.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="contactdelete"></a>
# **ContactDelete**
> void ContactDelete (string accountId, string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ContactDeleteExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.ContactDelete(accountId, id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.ContactDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="contactid"></a>
# **ContactId**
> Contact ContactId (string accountId, string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ContactIdExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Get record
                Contact result = apiInstance.ContactId(accountId, id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.ContactId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **id** | **string**|  | 

### Return type

[**Contact**](Contact.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="contactlist"></a>
# **ContactList**
> ContactListContainer ContactList (string accountId, int? offset = null, int? limit = null, string contactType = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ContactListExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var contactType = contactType_example;  // string |  (optional) 

            try
            {
                // List records
                ContactListContainer result = apiInstance.ContactList(accountId, offset, limit, contactType);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.ContactList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **contactType** | **string**|  | [optional] 

### Return type

[**ContactListContainer**](ContactListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="contacttypelist"></a>
# **ContactTypeList**
> ContactTypeListContainer ContactTypeList ()

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ContactTypeListExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();

            try
            {
                // List records
                ContactTypeListContainer result = apiInstance.ContactTypeList();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.ContactTypeList: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ContactTypeListContainer**](ContactTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="contactupdate"></a>
# **ContactUpdate**
> Contact ContactUpdate (string accountId, string id, Contact body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ContactUpdateExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var accountId = accountId_example;  // string | 
            var id = id_example;  // string | 
            var body = new Contact(); // Contact | 

            try
            {
                // Update record
                Contact result = apiInstance.ContactUpdate(accountId, id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.ContactUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **string**|  | 
 **id** | **string**|  | 
 **body** | [**Contact**](Contact.md)|  | 

### Return type

[**Contact**](Contact.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="currentaccountlist"></a>
# **CurrentAccountList**
> CurrentAccountListContainer CurrentAccountList (string id, int? offset = null, int? limit = null, string documentName = null, string documentType = null, string documentSerie = null, DateTime? startDate = null, DateTime? endDate = null, DateTime? startDueDate = null, DateTime? endDueDate = null, string currentAccountType = null, string account = null, List<string> salesman = null)

List customer or supplier current account

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class CurrentAccountListExample
    {
        public void main()
        {
            var apiInstance = new AccountApi();
            var id = id_example;  // string | 
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var documentName = documentName_example;  // string |  (optional) 
            var documentType = documentType_example;  // string |  (optional) 
            var documentSerie = documentSerie_example;  // string |  (optional) 
            var startDate = 2013-10-20T19:20:30+01:00;  // DateTime? |  (optional) 
            var endDate = 2013-10-20T19:20:30+01:00;  // DateTime? |  (optional) 
            var startDueDate = 2013-10-20T19:20:30+01:00;  // DateTime? |  (optional) 
            var endDueDate = 2013-10-20T19:20:30+01:00;  // DateTime? |  (optional) 
            var currentAccountType = currentAccountType_example;  // string |  (optional) 
            var account = account_example;  // string |  (optional) 
            var salesman = new List<string>(); // List<string> |  (optional) 

            try
            {
                // List customer or supplier current account
                CurrentAccountListContainer result = apiInstance.CurrentAccountList(id, offset, limit, documentName, documentType, documentSerie, startDate, endDate, startDueDate, endDueDate, currentAccountType, account, salesman);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling AccountApi.CurrentAccountList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **documentName** | **string**|  | [optional] 
 **documentType** | **string**|  | [optional] 
 **documentSerie** | **string**|  | [optional] 
 **startDate** | **DateTime?**|  | [optional] 
 **endDate** | **DateTime?**|  | [optional] 
 **startDueDate** | **DateTime?**|  | [optional] 
 **endDueDate** | **DateTime?**|  | [optional] 
 **currentAccountType** | **string**|  | [optional] 
 **account** | **string**|  | [optional] 
 **salesman** | [**List&lt;string&gt;**](string.md)|  | [optional] 

### Return type

[**CurrentAccountListContainer**](CurrentAccountListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

