# IO.Swagger.Api.DocumentApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DocumentCreate**](DocumentApi.md#documentcreate) | **POST** /document | Create record
[**DocumentDiscount**](DocumentApi.md#documentdiscount) | **POST** /document/discount | Get document discount
[**DocumentEmail**](DocumentApi.md#documentemail) | **PATCH** /document/email | Send document by mail
[**DocumentId**](DocumentApi.md#documentid) | **GET** /document/id/{id} | Get record
[**DocumentList**](DocumentApi.md#documentlist) | **GET** /document | List records
[**DocumenttypeList**](DocumentApi.md#documenttypelist) | **GET** /document/type | List document types and series


<a name="documentcreate"></a>
# **DocumentCreate**
> Document DocumentCreate (Document body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DocumentCreateExample
    {
        public void main()
        {
            var apiInstance = new DocumentApi();
            var body = new Document(); // Document | 

            try
            {
                // Create record
                Document result = apiInstance.DocumentCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DocumentApi.DocumentCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Document**](Document.md)|  | 

### Return type

[**Document**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="documentdiscount"></a>
# **DocumentDiscount**
> Document DocumentDiscount (Document body)

Get document discount

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DocumentDiscountExample
    {
        public void main()
        {
            var apiInstance = new DocumentApi();
            var body = new Document(); // Document | 

            try
            {
                // Get document discount
                Document result = apiInstance.DocumentDiscount(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DocumentApi.DocumentDiscount: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Document**](Document.md)|  | 

### Return type

[**Document**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="documentemail"></a>
# **DocumentEmail**
> void DocumentEmail (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null)

Send document by mail

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DocumentEmailExample
    {
        public void main()
        {
            var apiInstance = new DocumentApi();
            var id = id_example;  // string | 
            var toEmail = toEmail_example;  // string |  (optional) 
            var fromEmail = fromEmail_example;  // string |  (optional) 
            var fromName = fromName_example;  // string |  (optional) 
            var subject = subject_example;  // string |  (optional) 

            try
            {
                // Send document by mail
                apiInstance.DocumentEmail(id, toEmail, fromEmail, fromName, subject);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DocumentApi.DocumentEmail: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **toEmail** | **string**|  | [optional] 
 **fromEmail** | **string**|  | [optional] 
 **fromName** | **string**|  | [optional] 
 **subject** | **string**|  | [optional] 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="documentid"></a>
# **DocumentId**
> Document DocumentId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DocumentIdExample
    {
        public void main()
        {
            var apiInstance = new DocumentApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                Document result = apiInstance.DocumentId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DocumentApi.DocumentId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**Document**](Document.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="documentlist"></a>
# **DocumentList**
> DocumentListContainer DocumentList (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DocumentListExample
    {
        public void main()
        {
            var apiInstance = new DocumentApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var number = 56;  // int? |  (optional) 
            var startDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var endDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var type1 = type1_example;  // string |  (optional) 
            var type2 = type2_example;  // string |  (optional) 
            var updateDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var account = account_example;  // string |  (optional) 
            var product = product_example;  // string |  (optional) 
            var productCategory = productCategory_example;  // string |  (optional) 
            var deleted = true;  // bool? |  (optional) 
            var name = name_example;  // string |  (optional) 
            var type = new List<string>(); // List<string> |  (optional) 
            var serie = new List<string>(); // List<string> |  (optional) 
            var salesman = new List<string>(); // List<string> |  (optional) 
            var extraFieldsExpression = extraFieldsExpression_example;  // string |  (optional) 
            var extraFields = new List<string>(); // List<string> |  (optional) 

            try
            {
                // List records
                DocumentListContainer result = apiInstance.DocumentList(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DocumentApi.DocumentList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **number** | **int?**|  | [optional] 
 **startDate** | **DateTime?**| ISO 8601 | [optional] 
 **endDate** | **DateTime?**| ISO 8601 | [optional] 
 **type1** | **string**|  | [optional] 
 **type2** | **string**|  | [optional] 
 **updateDate** | **DateTime?**| ISO 8601 | [optional] 
 **account** | **string**|  | [optional] 
 **product** | **string**|  | [optional] 
 **productCategory** | **string**|  | [optional] 
 **deleted** | **bool?**|  | [optional] 
 **name** | **string**|  | [optional] 
 **type** | [**List&lt;string&gt;**](string.md)|  | [optional] 
 **serie** | [**List&lt;string&gt;**](string.md)|  | [optional] 
 **salesman** | [**List&lt;string&gt;**](string.md)|  | [optional] 
 **extraFieldsExpression** | **string**|  | [optional] 
 **extraFields** | [**List&lt;string&gt;**](string.md)|  | [optional] 

### Return type

[**DocumentListContainer**](DocumentListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="documenttypelist"></a>
# **DocumenttypeList**
> DocumentTypeListContainer DocumenttypeList (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null)

List document types and series

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DocumenttypeListExample
    {
        public void main()
        {
            var apiInstance = new DocumentApi();
            var type = type_example;  // string |  (optional) 
            var serie = serie_example;  // string |  (optional) 
            var type1 = type1_example;  // string |  (optional) 
            var type2 = type2_example;  // string |  (optional) 
            var userType = userType_example;  // string |  (optional) 
            var userId = userId_example;  // string |  (optional) 

            try
            {
                // List document types and series
                DocumentTypeListContainer result = apiInstance.DocumenttypeList(type, serie, type1, type2, userType, userId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling DocumentApi.DocumenttypeList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **type** | **string**|  | [optional] 
 **serie** | **string**|  | [optional] 
 **type1** | **string**|  | [optional] 
 **type2** | **string**|  | [optional] 
 **userType** | **string**|  | [optional] 
 **userId** | **string**|  | [optional] 

### Return type

[**DocumentTypeListContainer**](DocumentTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

