# IO.Swagger.Api.HrApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**EmployeeAllFiles**](HrApi.md#employeeallfiles) | **GET** /hr/employee/files | Get files
[**EmployeeCreate**](HrApi.md#employeecreate) | **POST** /hr/employee | Create record
[**EmployeeDelete**](HrApi.md#employeedelete) | **DELETE** /hr/employee/{id} | Delete record
[**EmployeeFileDownloadBase64**](HrApi.md#employeefiledownloadbase64) | **GET** /hr/employee/id/{id}/file/{fileId}/base64 | Get record file
[**EmployeeFileDownloadBin**](HrApi.md#employeefiledownloadbin) | **GET** /hr/employee/id/{id}/file/{fileId}/bin | Get record file
[**EmployeeFiles**](HrApi.md#employeefiles) | **GET** /hr/employee/id/{id}/file | Get record files
[**EmployeeId**](HrApi.md#employeeid) | **GET** /hr/employee/id/{id} | Get record
[**EmployeeList**](HrApi.md#employeelist) | **GET** /hr/employee | List records
[**EmployeeUpdate**](HrApi.md#employeeupdate) | **PUT** /hr/employee/{id} | Update record
[**MonthlyPayrollSupplementCreate**](HrApi.md#monthlypayrollsupplementcreate) | **POST** /hr/monthly_payroll_supplement | Create record
[**MonthlyPayrollSupplementCreatePack**](HrApi.md#monthlypayrollsupplementcreatepack) | **POST** /hr/monthly_payroll_supplement/pack/{packid} | Create record
[**MonthlyPayrollSupplementDelete**](HrApi.md#monthlypayrollsupplementdelete) | **DELETE** /hr/monthly_payroll_supplement/id/{id} | Delete record
[**MonthlyPayrollSupplementDeleteExternalId**](HrApi.md#monthlypayrollsupplementdeleteexternalid) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id} | Delete record
[**MonthlyPayrollSupplementDeleteExternalIdPack**](HrApi.md#monthlypayrollsupplementdeleteexternalidpack) | **DELETE** /hr/monthly_payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
[**MonthlyPayrollSupplementDeletePack**](HrApi.md#monthlypayrollsupplementdeletepack) | **DELETE** /hr/monthly_payroll_supplement/id/{id}/pack/{packid} | Delete record
[**MonthlyPayrollSupplementExternalId**](HrApi.md#monthlypayrollsupplementexternalid) | **GET** /hr/monthly_payroll_supplement/external/{source}/{id} | Get record
[**MonthlyPayrollSupplementId**](HrApi.md#monthlypayrollsupplementid) | **GET** /hr/monthly_payroll_supplement/id/{id} | Get record
[**MonthlyPayrollSupplementList**](HrApi.md#monthlypayrollsupplementlist) | **GET** /hr/monthly_payroll_supplement | List records
[**MonthlyPayrollSupplementUpdate**](HrApi.md#monthlypayrollsupplementupdate) | **PUT** /hr/monthly_payroll_supplement/{id} | Update record
[**MonthlyPayrollSupplementUpdatePack**](HrApi.md#monthlypayrollsupplementupdatepack) | **PUT** /hr/monthly_payroll_supplement/{id}/pack/{packid} | Update record
[**PayrollSupplementCreate**](HrApi.md#payrollsupplementcreate) | **POST** /hr/payroll_supplement | Create record
[**PayrollSupplementCreatePack**](HrApi.md#payrollsupplementcreatepack) | **POST** /hr/payroll_supplement/pack/{packid} | Create record
[**PayrollSupplementDelete**](HrApi.md#payrollsupplementdelete) | **DELETE** /hr/payroll_supplement/id/{id} | Delete record
[**PayrollSupplementDeleteExternalId**](HrApi.md#payrollsupplementdeleteexternalid) | **DELETE** /hr/payroll_supplement/external/{source}/{id} | Delete record
[**PayrollSupplementDeleteExternalIdPack**](HrApi.md#payrollsupplementdeleteexternalidpack) | **DELETE** /hr/payroll_supplement/external/{source}/{id}/pack/{packid} | Delete record
[**PayrollSupplementDeletePack**](HrApi.md#payrollsupplementdeletepack) | **DELETE** /hr/payroll_supplement/id/{id}/pack/{packid} | Delete record
[**PayrollSupplementExternalId**](HrApi.md#payrollsupplementexternalid) | **GET** /hr/payroll_supplement/external/{source}/{id} | Get record
[**PayrollSupplementId**](HrApi.md#payrollsupplementid) | **GET** /hr/payroll_supplement/id/{id} | Get record
[**PayrollSupplementList**](HrApi.md#payrollsupplementlist) | **GET** /hr/payroll_supplement | List records
[**PayrollSupplementTypeList**](HrApi.md#payrollsupplementtypelist) | **GET** /hr/payroll_supplement/payroll_supplement_type | List records
[**PayrollSupplementUpdate**](HrApi.md#payrollsupplementupdate) | **PUT** /hr/payroll_supplement/{id} | Update record
[**PayrollSupplementUpdatePack**](HrApi.md#payrollsupplementupdatepack) | **PUT** /hr/payroll_supplement/{id}/pack/{packid} | Update record
[**TimeAttendanceId**](HrApi.md#timeattendanceid) | **GET** /hr/time_attendance/id/{id} | Get record
[**TimeAttendanceList**](HrApi.md#timeattendancelist) | **GET** /hr/time_attendance | List records
[**TimeExtraCreate**](HrApi.md#timeextracreate) | **POST** /hr/time_extra | Create record
[**TimeExtraCreatePack**](HrApi.md#timeextracreatepack) | **POST** /hr/time_extra/pack/{packid} | Create record
[**TimeExtraDelete**](HrApi.md#timeextradelete) | **DELETE** /hr/time_extra/id/{id} | Delete record
[**TimeExtraDeleteExternalId**](HrApi.md#timeextradeleteexternalid) | **DELETE** /hr/time_extra/external/{source}/{id} | Delete record
[**TimeExtraDeleteExternalIdPack**](HrApi.md#timeextradeleteexternalidpack) | **DELETE** /hr/time_extra/external/{source}/{id}/pack/{packid} | Delete record
[**TimeExtraDeletePack**](HrApi.md#timeextradeletepack) | **DELETE** /hr/time_extra/id/{id}/pack/{packid} | Delete record
[**TimeExtraExternalId**](HrApi.md#timeextraexternalid) | **GET** /hr/time_extra/external/{source}/{id} | Get record
[**TimeExtraId**](HrApi.md#timeextraid) | **GET** /hr/time_extra/id/{id} | Get record
[**TimeExtraList**](HrApi.md#timeextralist) | **GET** /hr/time_extra | List records
[**TimeExtraTypeList**](HrApi.md#timeextratypelist) | **GET** /hr/time_extra/time_extra_type | List records
[**TimeExtraUpdate**](HrApi.md#timeextraupdate) | **PUT** /hr/time_extra/{id} | Update record
[**TimeExtraUpdatePack**](HrApi.md#timeextraupdatepack) | **PUT** /hr/time_extra/{id}/pack/{packid} | Update record
[**TimeOffLeaveCreate**](HrApi.md#timeoffleavecreate) | **POST** /hr/time_off_leave | Create record
[**TimeOffLeaveDelete**](HrApi.md#timeoffleavedelete) | **DELETE** /hr/time_off_leave/id/{id} | Delete record
[**TimeOffLeaveDeleteExternalId**](HrApi.md#timeoffleavedeleteexternalid) | **DELETE** /hr/time_off_leave/external/{source}/{id} | Delete record
[**TimeOffLeaveExternalId**](HrApi.md#timeoffleaveexternalid) | **GET** /hr/time_off_leave/external/{source}/{id} | Get record
[**TimeOffLeaveId**](HrApi.md#timeoffleaveid) | **GET** /hr/time_off_leave/id/{id} | Get record
[**TimeOffLeaveList**](HrApi.md#timeoffleavelist) | **GET** /hr/time_off_leave | List records
[**TimeOffLeaveUpdate**](HrApi.md#timeoffleaveupdate) | **PUT** /hr/time_off_leave/{id} | Update record
[**TimeOffLeavetypeList**](HrApi.md#timeoffleavetypelist) | **GET** /hr/time_off_leave/time_off_leave_type | List records


<a name="employeeallfiles"></a>
# **EmployeeAllFiles**
> FileListContainer EmployeeAllFiles (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null)

Get files

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeAllFilesExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var hrFileType = hrFileType_example;  // string |  (optional) 
            var employeeId = employeeId_example;  // string |  (optional) 
            var employeeDeleted = true;  // bool? |  (optional) 
            var start = 2013-10-20T19:20:30+01:00;  // DateTime? |  (optional) 
            var end = 2013-10-20T19:20:30+01:00;  // DateTime? |  (optional) 

            try
            {
                // Get files
                FileListContainer result = apiInstance.EmployeeAllFiles(offset, limit, hrFileType, employeeId, employeeDeleted, start, end);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeAllFiles: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **hrFileType** | **string**|  | [optional] 
 **employeeId** | **string**|  | [optional] 
 **employeeDeleted** | **bool?**|  | [optional] 
 **start** | **DateTime?**|  | [optional] 
 **end** | **DateTime?**|  | [optional] 

### Return type

[**FileListContainer**](FileListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeecreate"></a>
# **EmployeeCreate**
> Employee EmployeeCreate (Employee body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeCreateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var body = new Employee(); // Employee | 

            try
            {
                // Create record
                Employee result = apiInstance.EmployeeCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Employee**](Employee.md)|  | 

### Return type

[**Employee**](Employee.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeedelete"></a>
# **EmployeeDelete**
> void EmployeeDelete (string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeDeleteExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.EmployeeDelete(id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeefiledownloadbase64"></a>
# **EmployeeFileDownloadBase64**
> string EmployeeFileDownloadBase64 (string id, string fileId)

Get record file

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeFileDownloadBase64Example
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var fileId = fileId_example;  // string | 

            try
            {
                // Get record file
                string result = apiInstance.EmployeeFileDownloadBase64(id, fileId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeFileDownloadBase64: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **fileId** | **string**|  | 

### Return type

**string**

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: text/plain

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeefiledownloadbin"></a>
# **EmployeeFileDownloadBin**
> ModelFile EmployeeFileDownloadBin (string id, string fileId)

Get record file

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeFileDownloadBinExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var fileId = fileId_example;  // string | 

            try
            {
                // Get record file
                ModelFile result = apiInstance.EmployeeFileDownloadBin(id, fileId);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeFileDownloadBin: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **fileId** | **string**|  | 

### Return type

[**ModelFile**](ModelFile.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/octet-stream

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeefiles"></a>
# **EmployeeFiles**
> FileListContainer EmployeeFiles (string id)

Get record files

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeFilesExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Get record files
                FileListContainer result = apiInstance.EmployeeFiles(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeFiles: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**FileListContainer**](FileListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeeid"></a>
# **EmployeeId**
> Employee EmployeeId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                Employee result = apiInstance.EmployeeId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**Employee**](Employee.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeelist"></a>
# **EmployeeList**
> EmployeeListContainer EmployeeList (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var name = name_example;  // string |  (optional) 
            var nationalNumber = nationalNumber_example;  // string |  (optional) 
            var taxNumber = taxNumber_example;  // string |  (optional) 
            var email = email_example;  // string |  (optional) 
            var deleted = true;  // bool? |  (optional) 
            var ids = new List<string>(); // List<string> |  (optional) 

            try
            {
                // List records
                EmployeeListContainer result = apiInstance.EmployeeList(offset, limit, name, nationalNumber, taxNumber, email, deleted, ids);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **name** | **string**|  | [optional] 
 **nationalNumber** | **string**|  | [optional] 
 **taxNumber** | **string**|  | [optional] 
 **email** | **string**|  | [optional] 
 **deleted** | **bool?**|  | [optional] 
 **ids** | [**List&lt;string&gt;**](string.md)|  | [optional] 

### Return type

[**EmployeeListContainer**](EmployeeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="employeeupdate"></a>
# **EmployeeUpdate**
> Employee EmployeeUpdate (string id, Employee body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class EmployeeUpdateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var body = new Employee(); // Employee | 

            try
            {
                // Update record
                Employee result = apiInstance.EmployeeUpdate(id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.EmployeeUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **body** | [**Employee**](Employee.md)|  | 

### Return type

[**Employee**](Employee.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementcreate"></a>
# **MonthlyPayrollSupplementCreate**
> PayrollSupplement MonthlyPayrollSupplementCreate (PayrollSupplement body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementCreateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Create record
                PayrollSupplement result = apiInstance.MonthlyPayrollSupplementCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementcreatepack"></a>
# **MonthlyPayrollSupplementCreatePack**
> PayrollSupplement MonthlyPayrollSupplementCreatePack (string packid, PayrollSupplement body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementCreatePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var packid = packid_example;  // string | 
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Create record
                PayrollSupplement result = apiInstance.MonthlyPayrollSupplementCreatePack(packid, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementCreatePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **packid** | **string**|  | 
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementdelete"></a>
# **MonthlyPayrollSupplementDelete**
> void MonthlyPayrollSupplementDelete (string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementDeleteExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.MonthlyPayrollSupplementDelete(id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementdeleteexternalid"></a>
# **MonthlyPayrollSupplementDeleteExternalId**
> void MonthlyPayrollSupplementDeleteExternalId (string source, string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementDeleteExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.MonthlyPayrollSupplementDeleteExternalId(source, id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementDeleteExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementdeleteexternalidpack"></a>
# **MonthlyPayrollSupplementDeleteExternalIdPack**
> void MonthlyPayrollSupplementDeleteExternalIdPack (string source, string id, string packid)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementDeleteExternalIdPackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 

            try
            {
                // Delete record
                apiInstance.MonthlyPayrollSupplementDeleteExternalIdPack(source, id, packid);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementDeleteExternalIdPack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 
 **packid** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementdeletepack"></a>
# **MonthlyPayrollSupplementDeletePack**
> void MonthlyPayrollSupplementDeletePack (string id, string packid)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementDeletePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 

            try
            {
                // Delete record
                apiInstance.MonthlyPayrollSupplementDeletePack(id, packid);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementDeletePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **packid** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementexternalid"></a>
# **MonthlyPayrollSupplementExternalId**
> PayrollSupplement MonthlyPayrollSupplementExternalId (string source, string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Get record
                PayrollSupplement result = apiInstance.MonthlyPayrollSupplementExternalId(source, id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementid"></a>
# **MonthlyPayrollSupplementId**
> PayrollSupplement MonthlyPayrollSupplementId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                PayrollSupplement result = apiInstance.MonthlyPayrollSupplementId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementlist"></a>
# **MonthlyPayrollSupplementList**
> PayrollSupplementListContainer MonthlyPayrollSupplementList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var employee = employee_example;  // string |  (optional) 
            var type = type_example;  // string |  (optional) 
            var startDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var endDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 

            try
            {
                // List records
                PayrollSupplementListContainer result = apiInstance.MonthlyPayrollSupplementList(offset, limit, employee, type, startDate, endDate);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **employee** | **string**|  | [optional] 
 **type** | **string**|  | [optional] 
 **startDate** | **DateTime?**| ISO 8601 | [optional] 
 **endDate** | **DateTime?**| ISO 8601 | [optional] 

### Return type

[**PayrollSupplementListContainer**](PayrollSupplementListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementupdate"></a>
# **MonthlyPayrollSupplementUpdate**
> PayrollSupplement MonthlyPayrollSupplementUpdate (string id, PayrollSupplement body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementUpdateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Update record
                PayrollSupplement result = apiInstance.MonthlyPayrollSupplementUpdate(id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="monthlypayrollsupplementupdatepack"></a>
# **MonthlyPayrollSupplementUpdatePack**
> PayrollSupplement MonthlyPayrollSupplementUpdatePack (string id, string packid, PayrollSupplement body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MonthlyPayrollSupplementUpdatePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Update record
                PayrollSupplement result = apiInstance.MonthlyPayrollSupplementUpdatePack(id, packid, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.MonthlyPayrollSupplementUpdatePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **packid** | **string**|  | 
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementcreate"></a>
# **PayrollSupplementCreate**
> PayrollSupplement PayrollSupplementCreate (PayrollSupplement body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementCreateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Create record
                PayrollSupplement result = apiInstance.PayrollSupplementCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementcreatepack"></a>
# **PayrollSupplementCreatePack**
> PayrollSupplement PayrollSupplementCreatePack (string packid, PayrollSupplement body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementCreatePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var packid = packid_example;  // string | 
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Create record
                PayrollSupplement result = apiInstance.PayrollSupplementCreatePack(packid, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementCreatePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **packid** | **string**|  | 
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementdelete"></a>
# **PayrollSupplementDelete**
> void PayrollSupplementDelete (string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementDeleteExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.PayrollSupplementDelete(id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementdeleteexternalid"></a>
# **PayrollSupplementDeleteExternalId**
> void PayrollSupplementDeleteExternalId (string source, string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementDeleteExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.PayrollSupplementDeleteExternalId(source, id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementDeleteExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementdeleteexternalidpack"></a>
# **PayrollSupplementDeleteExternalIdPack**
> void PayrollSupplementDeleteExternalIdPack (string source, string id, string packid)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementDeleteExternalIdPackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 

            try
            {
                // Delete record
                apiInstance.PayrollSupplementDeleteExternalIdPack(source, id, packid);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementDeleteExternalIdPack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 
 **packid** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementdeletepack"></a>
# **PayrollSupplementDeletePack**
> void PayrollSupplementDeletePack (string id, string packid)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementDeletePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 

            try
            {
                // Delete record
                apiInstance.PayrollSupplementDeletePack(id, packid);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementDeletePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **packid** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementexternalid"></a>
# **PayrollSupplementExternalId**
> PayrollSupplement PayrollSupplementExternalId (string source, string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Get record
                PayrollSupplement result = apiInstance.PayrollSupplementExternalId(source, id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementid"></a>
# **PayrollSupplementId**
> PayrollSupplement PayrollSupplementId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                PayrollSupplement result = apiInstance.PayrollSupplementId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementlist"></a>
# **PayrollSupplementList**
> PayrollSupplementListContainer PayrollSupplementList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var employee = employee_example;  // string |  (optional) 
            var type = type_example;  // string |  (optional) 
            var startDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var endDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 

            try
            {
                // List records
                PayrollSupplementListContainer result = apiInstance.PayrollSupplementList(offset, limit, employee, type, startDate, endDate);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **employee** | **string**|  | [optional] 
 **type** | **string**|  | [optional] 
 **startDate** | **DateTime?**| ISO 8601 | [optional] 
 **endDate** | **DateTime?**| ISO 8601 | [optional] 

### Return type

[**PayrollSupplementListContainer**](PayrollSupplementListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementtypelist"></a>
# **PayrollSupplementTypeList**
> PayrollSupplementTypeListContainer PayrollSupplementTypeList ()

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementTypeListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();

            try
            {
                // List records
                PayrollSupplementTypeListContainer result = apiInstance.PayrollSupplementTypeList();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementTypeList: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**PayrollSupplementTypeListContainer**](PayrollSupplementTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementupdate"></a>
# **PayrollSupplementUpdate**
> PayrollSupplement PayrollSupplementUpdate (string id, PayrollSupplement body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementUpdateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Update record
                PayrollSupplement result = apiInstance.PayrollSupplementUpdate(id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="payrollsupplementupdatepack"></a>
# **PayrollSupplementUpdatePack**
> PayrollSupplement PayrollSupplementUpdatePack (string id, string packid, PayrollSupplement body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PayrollSupplementUpdatePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 
            var body = new PayrollSupplement(); // PayrollSupplement | 

            try
            {
                // Update record
                PayrollSupplement result = apiInstance.PayrollSupplementUpdatePack(id, packid, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.PayrollSupplementUpdatePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **packid** | **string**|  | 
 **body** | [**PayrollSupplement**](PayrollSupplement.md)|  | 

### Return type

[**PayrollSupplement**](PayrollSupplement.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeattendanceid"></a>
# **TimeAttendanceId**
> TimeAttendance TimeAttendanceId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeAttendanceIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                TimeAttendance result = apiInstance.TimeAttendanceId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeAttendanceId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**TimeAttendance**](TimeAttendance.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeattendancelist"></a>
# **TimeAttendanceList**
> TimeAttendanceListContainer TimeAttendanceList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeAttendanceListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var employee = employee_example;  // string |  (optional) 
            var type = type_example;  // string |  (optional) 
            var startDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var endDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 

            try
            {
                // List records
                TimeAttendanceListContainer result = apiInstance.TimeAttendanceList(offset, limit, employee, type, startDate, endDate);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeAttendanceList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **employee** | **string**|  | [optional] 
 **type** | **string**|  | [optional] 
 **startDate** | **DateTime?**| ISO 8601 | [optional] 
 **endDate** | **DateTime?**| ISO 8601 | [optional] 

### Return type

[**TimeAttendanceListContainer**](TimeAttendanceListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextracreate"></a>
# **TimeExtraCreate**
> TimeExtra TimeExtraCreate (TimeExtra body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraCreateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var body = new TimeExtra(); // TimeExtra | 

            try
            {
                // Create record
                TimeExtra result = apiInstance.TimeExtraCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TimeExtra**](TimeExtra.md)|  | 

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextracreatepack"></a>
# **TimeExtraCreatePack**
> TimeExtra TimeExtraCreatePack (string packid, TimeExtra body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraCreatePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var packid = packid_example;  // string | 
            var body = new TimeExtra(); // TimeExtra | 

            try
            {
                // Create record
                TimeExtra result = apiInstance.TimeExtraCreatePack(packid, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraCreatePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **packid** | **string**|  | 
 **body** | [**TimeExtra**](TimeExtra.md)|  | 

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextradelete"></a>
# **TimeExtraDelete**
> void TimeExtraDelete (string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraDeleteExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.TimeExtraDelete(id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextradeleteexternalid"></a>
# **TimeExtraDeleteExternalId**
> void TimeExtraDeleteExternalId (string source, string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraDeleteExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.TimeExtraDeleteExternalId(source, id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraDeleteExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextradeleteexternalidpack"></a>
# **TimeExtraDeleteExternalIdPack**
> void TimeExtraDeleteExternalIdPack (string source, string id, string packid)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraDeleteExternalIdPackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 

            try
            {
                // Delete record
                apiInstance.TimeExtraDeleteExternalIdPack(source, id, packid);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraDeleteExternalIdPack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 
 **packid** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextradeletepack"></a>
# **TimeExtraDeletePack**
> void TimeExtraDeletePack (string id, string packid)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraDeletePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 

            try
            {
                // Delete record
                apiInstance.TimeExtraDeletePack(id, packid);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraDeletePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **packid** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextraexternalid"></a>
# **TimeExtraExternalId**
> TimeExtra TimeExtraExternalId (string source, string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Get record
                TimeExtra result = apiInstance.TimeExtraExternalId(source, id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextraid"></a>
# **TimeExtraId**
> TimeExtra TimeExtraId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                TimeExtra result = apiInstance.TimeExtraId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextralist"></a>
# **TimeExtraList**
> TimeExtraListContainer TimeExtraList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var employee = employee_example;  // string |  (optional) 
            var type = type_example;  // string |  (optional) 
            var startDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var endDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 

            try
            {
                // List records
                TimeExtraListContainer result = apiInstance.TimeExtraList(offset, limit, employee, type, startDate, endDate);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **employee** | **string**|  | [optional] 
 **type** | **string**|  | [optional] 
 **startDate** | **DateTime?**| ISO 8601 | [optional] 
 **endDate** | **DateTime?**| ISO 8601 | [optional] 

### Return type

[**TimeExtraListContainer**](TimeExtraListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextratypelist"></a>
# **TimeExtraTypeList**
> TimeExtraTypeListContainer TimeExtraTypeList ()

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraTypeListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();

            try
            {
                // List records
                TimeExtraTypeListContainer result = apiInstance.TimeExtraTypeList();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraTypeList: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**TimeExtraTypeListContainer**](TimeExtraTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextraupdate"></a>
# **TimeExtraUpdate**
> TimeExtra TimeExtraUpdate (string id, TimeExtra body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraUpdateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var body = new TimeExtra(); // TimeExtra | 

            try
            {
                // Update record
                TimeExtra result = apiInstance.TimeExtraUpdate(id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **body** | [**TimeExtra**](TimeExtra.md)|  | 

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeextraupdatepack"></a>
# **TimeExtraUpdatePack**
> TimeExtra TimeExtraUpdatePack (string id, string packid, TimeExtra body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeExtraUpdatePackExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var packid = packid_example;  // string | 
            var body = new TimeExtra(); // TimeExtra | 

            try
            {
                // Update record
                TimeExtra result = apiInstance.TimeExtraUpdatePack(id, packid, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeExtraUpdatePack: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **packid** | **string**|  | 
 **body** | [**TimeExtra**](TimeExtra.md)|  | 

### Return type

[**TimeExtra**](TimeExtra.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleavecreate"></a>
# **TimeOffLeaveCreate**
> TimeOffLeave TimeOffLeaveCreate (TimeOffLeave body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeaveCreateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var body = new TimeOffLeave(); // TimeOffLeave | 

            try
            {
                // Create record
                TimeOffLeave result = apiInstance.TimeOffLeaveCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeaveCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**TimeOffLeave**](TimeOffLeave.md)|  | 

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleavedelete"></a>
# **TimeOffLeaveDelete**
> void TimeOffLeaveDelete (string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeaveDeleteExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.TimeOffLeaveDelete(id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeaveDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleavedeleteexternalid"></a>
# **TimeOffLeaveDeleteExternalId**
> void TimeOffLeaveDeleteExternalId (string source, string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeaveDeleteExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.TimeOffLeaveDeleteExternalId(source, id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeaveDeleteExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleaveexternalid"></a>
# **TimeOffLeaveExternalId**
> TimeOffLeave TimeOffLeaveExternalId (string source, string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeaveExternalIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var source = source_example;  // string | 
            var id = id_example;  // string | 

            try
            {
                // Get record
                TimeOffLeave result = apiInstance.TimeOffLeaveExternalId(source, id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeaveExternalId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **source** | **string**|  | 
 **id** | **string**|  | 

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleaveid"></a>
# **TimeOffLeaveId**
> TimeOffLeave TimeOffLeaveId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeaveIdExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                TimeOffLeave result = apiInstance.TimeOffLeaveId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeaveId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleavelist"></a>
# **TimeOffLeaveList**
> TimeOffLeaveListContainer TimeOffLeaveList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeaveListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var employee = employee_example;  // string |  (optional) 
            var type = type_example;  // string |  (optional) 
            var startDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var endDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var approved = true;  // bool? |  (optional) 

            try
            {
                // List records
                TimeOffLeaveListContainer result = apiInstance.TimeOffLeaveList(offset, limit, employee, type, startDate, endDate, approved);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeaveList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **employee** | **string**|  | [optional] 
 **type** | **string**|  | [optional] 
 **startDate** | **DateTime?**| ISO 8601 | [optional] 
 **endDate** | **DateTime?**| ISO 8601 | [optional] 
 **approved** | **bool?**|  | [optional] 

### Return type

[**TimeOffLeaveListContainer**](TimeOffLeaveListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleaveupdate"></a>
# **TimeOffLeaveUpdate**
> TimeOffLeave TimeOffLeaveUpdate (string id, TimeOffLeave body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeaveUpdateExample
    {
        public void main()
        {
            var apiInstance = new HrApi();
            var id = id_example;  // string | 
            var body = new TimeOffLeave(); // TimeOffLeave | 

            try
            {
                // Update record
                TimeOffLeave result = apiInstance.TimeOffLeaveUpdate(id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeaveUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **body** | [**TimeOffLeave**](TimeOffLeave.md)|  | 

### Return type

[**TimeOffLeave**](TimeOffLeave.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="timeoffleavetypelist"></a>
# **TimeOffLeavetypeList**
> TimeOffLeaveTypeListContainer TimeOffLeavetypeList ()

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class TimeOffLeavetypeListExample
    {
        public void main()
        {
            var apiInstance = new HrApi();

            try
            {
                // List records
                TimeOffLeaveTypeListContainer result = apiInstance.TimeOffLeavetypeList();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling HrApi.TimeOffLeavetypeList: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**TimeOffLeaveTypeListContainer**](TimeOffLeaveTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

