# IO.Swagger.Api.ProductApi

All URIs are relative to *https://e2e.pt/ws*

Method | HTTP request | Description
------------- | ------------- | -------------
[**PriceList**](ProductApi.md#pricelist) | **GET** /product/price | List product prices
[**PriceTypeList**](ProductApi.md#pricetypelist) | **GET** /product/price/type | List product prices type
[**ProductCategoryList**](ProductApi.md#productcategorylist) | **GET** /product/category | List product categories
[**ProductCreate**](ProductApi.md#productcreate) | **POST** /product | Create record
[**ProductDelete**](ProductApi.md#productdelete) | **DELETE** /product/{id} | Delete record
[**ProductId**](ProductApi.md#productid) | **GET** /product/id/{id} | Get record
[**ProductList**](ProductApi.md#productlist) | **GET** /product | List records
[**ProductUpdate**](ProductApi.md#productupdate) | **PUT** /product/{id} | Update record
[**StockList**](ProductApi.md#stocklist) | **GET** /product/stock | List records


<a name="pricelist"></a>
# **PriceList**
> PriceListContainer PriceList (int? offset = null, int? limit = null, string priceType = null, string currency = null, string unit = null, List<string> productIds = null)

List product prices

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PriceListExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var priceType = priceType_example;  // string |  (optional) 
            var currency = currency_example;  // string |  (optional) 
            var unit = unit_example;  // string |  (optional) 
            var productIds = new List<string>(); // List<string> |  (optional) 

            try
            {
                // List product prices
                PriceListContainer result = apiInstance.PriceList(offset, limit, priceType, currency, unit, productIds);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.PriceList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **priceType** | **string**|  | [optional] 
 **currency** | **string**|  | [optional] 
 **unit** | **string**|  | [optional] 
 **productIds** | [**List&lt;string&gt;**](string.md)|  | [optional] 

### Return type

[**PriceListContainer**](PriceListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="pricetypelist"></a>
# **PriceTypeList**
> PriceTypeListContainer PriceTypeList ()

List product prices type

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PriceTypeListExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();

            try
            {
                // List product prices type
                PriceTypeListContainer result = apiInstance.PriceTypeList();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.PriceTypeList: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**PriceTypeListContainer**](PriceTypeListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="productcategorylist"></a>
# **ProductCategoryList**
> ProductCategoryListContainer ProductCategoryList ()

List product categories

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ProductCategoryListExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();

            try
            {
                // List product categories
                ProductCategoryListContainer result = apiInstance.ProductCategoryList();
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.ProductCategoryList: " + e.Message );
            }
        }
    }
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**ProductCategoryListContainer**](ProductCategoryListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="productcreate"></a>
# **ProductCreate**
> Product ProductCreate (Product body)

Create record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ProductCreateExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();
            var body = new Product(); // Product | 

            try
            {
                // Create record
                Product result = apiInstance.ProductCreate(body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.ProductCreate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Product**](Product.md)|  | 

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="productdelete"></a>
# **ProductDelete**
> void ProductDelete (string id)

Delete record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ProductDeleteExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();
            var id = id_example;  // string | 

            try
            {
                // Delete record
                apiInstance.ProductDelete(id);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.ProductDelete: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="productid"></a>
# **ProductId**
> Product ProductId (string id)

Get record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ProductIdExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();
            var id = id_example;  // string | 

            try
            {
                // Get record
                Product result = apiInstance.ProductId(id);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.ProductId: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="productlist"></a>
# **ProductList**
> ProductListContainer ProductList (int? offset = null, int? limit = null, string name = null, bool? published = null, DateTime? updateDate = null, string productCategory = null, bool? deleted = null, List<string> ids = null, string extraFieldsExpression = null, List<string> extraFields = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ProductListExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var name = name_example;  // string |  (optional) 
            var published = true;  // bool? |  (optional) 
            var updateDate = 2013-10-20T19:20:30+01:00;  // DateTime? | ISO 8601 (optional) 
            var productCategory = productCategory_example;  // string |  (optional) 
            var deleted = true;  // bool? |  (optional) 
            var ids = new List<string>(); // List<string> |  (optional) 
            var extraFieldsExpression = extraFieldsExpression_example;  // string |  (optional) 
            var extraFields = new List<string>(); // List<string> |  (optional) 

            try
            {
                // List records
                ProductListContainer result = apiInstance.ProductList(offset, limit, name, published, updateDate, productCategory, deleted, ids, extraFieldsExpression, extraFields);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.ProductList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **name** | **string**|  | [optional] 
 **published** | **bool?**|  | [optional] 
 **updateDate** | **DateTime?**| ISO 8601 | [optional] 
 **productCategory** | **string**|  | [optional] 
 **deleted** | **bool?**|  | [optional] 
 **ids** | [**List&lt;string&gt;**](string.md)|  | [optional] 
 **extraFieldsExpression** | **string**|  | [optional] 
 **extraFields** | [**List&lt;string&gt;**](string.md)|  | [optional] 

### Return type

[**ProductListContainer**](ProductListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="productupdate"></a>
# **ProductUpdate**
> Product ProductUpdate (string id, Product body)

Update record

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class ProductUpdateExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();
            var id = id_example;  // string | 
            var body = new Product(); // Product | 

            try
            {
                // Update record
                Product result = apiInstance.ProductUpdate(id, body);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.ProductUpdate: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **string**|  | 
 **body** | [**Product**](Product.md)|  | 

### Return type

[**Product**](Product.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="stocklist"></a>
# **StockList**
> StockListContainer StockList (int? offset = null, int? limit = null, string unit = null, List<string> productIds = null, List<string> warehouseIds = null)

List records

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class StockListExample
    {
        public void main()
        {
            var apiInstance = new ProductApi();
            var offset = 56;  // int? |  (optional)  (default to 0)
            var limit = 56;  // int? |  (optional)  (default to 100)
            var unit = unit_example;  // string |  (optional) 
            var productIds = new List<string>(); // List<string> |  (optional) 
            var warehouseIds = new List<string>(); // List<string> |  (optional) 

            try
            {
                // List records
                StockListContainer result = apiInstance.StockList(offset, limit, unit, productIds, warehouseIds);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ProductApi.StockList: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **offset** | **int?**|  | [optional] [default to 0]
 **limit** | **int?**|  | [optional] [default to 100]
 **unit** | **string**|  | [optional] 
 **productIds** | [**List&lt;string&gt;**](string.md)|  | [optional] 
 **warehouseIds** | [**List&lt;string&gt;**](string.md)|  | [optional] 

### Return type

[**StockListContainer**](StockListContainer.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

