/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDocumentApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Document</returns>
        Document DocumentCreate (Document body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Document</returns>
        ApiResponse<Document> DocumentCreateWithHttpInfo (Document body);
        /// <summary>
        /// Get document discount
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Document</returns>
        Document DocumentDiscount (Document body);

        /// <summary>
        /// Get document discount
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Document</returns>
        ApiResponse<Document> DocumentDiscountWithHttpInfo (Document body);
        /// <summary>
        /// Send document by mail
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns></returns>
        void DocumentEmail (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null);

        /// <summary>
        /// Send document by mail
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> DocumentEmailWithHttpInfo (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Document</returns>
        Document DocumentId (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Document</returns>
        ApiResponse<Document> DocumentIdWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>DocumentListContainer</returns>
        DocumentListContainer DocumentList (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>ApiResponse of DocumentListContainer</returns>
        ApiResponse<DocumentListContainer> DocumentListWithHttpInfo (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null);
        /// <summary>
        /// List document types and series
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>DocumentTypeListContainer</returns>
        DocumentTypeListContainer DocumenttypeList (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null);

        /// <summary>
        /// List document types and series
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>ApiResponse of DocumentTypeListContainer</returns>
        ApiResponse<DocumentTypeListContainer> DocumenttypeListWithHttpInfo (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of Document</returns>
        System.Threading.Tasks.Task<Document> DocumentCreateAsync (Document body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Document)</returns>
        System.Threading.Tasks.Task<ApiResponse<Document>> DocumentCreateAsyncWithHttpInfo (Document body);
        /// <summary>
        /// Get document discount
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of Document</returns>
        System.Threading.Tasks.Task<Document> DocumentDiscountAsync (Document body);

        /// <summary>
        /// Get document discount
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Document)</returns>
        System.Threading.Tasks.Task<ApiResponse<Document>> DocumentDiscountAsyncWithHttpInfo (Document body);
        /// <summary>
        /// Send document by mail
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task DocumentEmailAsync (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null);

        /// <summary>
        /// Send document by mail
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> DocumentEmailAsyncWithHttpInfo (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of Document</returns>
        System.Threading.Tasks.Task<Document> DocumentIdAsync (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (Document)</returns>
        System.Threading.Tasks.Task<ApiResponse<Document>> DocumentIdAsyncWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>Task of DocumentListContainer</returns>
        System.Threading.Tasks.Task<DocumentListContainer> DocumentListAsync (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>Task of ApiResponse (DocumentListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentListContainer>> DocumentListAsyncWithHttpInfo (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null);
        /// <summary>
        /// List document types and series
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>Task of DocumentTypeListContainer</returns>
        System.Threading.Tasks.Task<DocumentTypeListContainer> DocumenttypeListAsync (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null);

        /// <summary>
        /// List document types and series
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>Task of ApiResponse (DocumentTypeListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentTypeListContainer>> DocumenttypeListAsyncWithHttpInfo (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DocumentApi : IDocumentApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DocumentApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DocumentApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Document</returns>
        public Document DocumentCreate (Document body)
        {
             ApiResponse<Document> localVarResponse = DocumentCreateWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Document</returns>
        public ApiResponse< Document > DocumentCreateWithHttpInfo (Document body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DocumentApi->DocumentCreate");

            var localVarPath = "/document";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Document>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Document) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Document)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of Document</returns>
        public async System.Threading.Tasks.Task<Document> DocumentCreateAsync (Document body)
        {
             ApiResponse<Document> localVarResponse = await DocumentCreateAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Document)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Document>> DocumentCreateAsyncWithHttpInfo (Document body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DocumentApi->DocumentCreate");

            var localVarPath = "/document";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Document>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Document) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Document)));
        }

        /// <summary>
        /// Get document discount 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Document</returns>
        public Document DocumentDiscount (Document body)
        {
             ApiResponse<Document> localVarResponse = DocumentDiscountWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get document discount 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Document</returns>
        public ApiResponse< Document > DocumentDiscountWithHttpInfo (Document body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DocumentApi->DocumentDiscount");

            var localVarPath = "/document/discount";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentDiscount", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Document>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Document) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Document)));
        }

        /// <summary>
        /// Get document discount 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of Document</returns>
        public async System.Threading.Tasks.Task<Document> DocumentDiscountAsync (Document body)
        {
             ApiResponse<Document> localVarResponse = await DocumentDiscountAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get document discount 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Document)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Document>> DocumentDiscountAsyncWithHttpInfo (Document body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling DocumentApi->DocumentDiscount");

            var localVarPath = "/document/discount";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentDiscount", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Document>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Document) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Document)));
        }

        /// <summary>
        /// Send document by mail 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns></returns>
        public void DocumentEmail (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null)
        {
             DocumentEmailWithHttpInfo(id, toEmail, fromEmail, fromName, subject);
        }

        /// <summary>
        /// Send document by mail 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> DocumentEmailWithHttpInfo (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling DocumentApi->DocumentEmail");

            var localVarPath = "/document/email";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (toEmail != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "toEmail", toEmail)); // query parameter
            if (fromEmail != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fromEmail", fromEmail)); // query parameter
            if (fromName != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fromName", fromName)); // query parameter
            if (subject != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subject", subject)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentEmail", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Send document by mail 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task DocumentEmailAsync (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null)
        {
             await DocumentEmailAsyncWithHttpInfo(id, toEmail, fromEmail, fromName, subject);

        }

        /// <summary>
        /// Send document by mail 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="toEmail"> (optional)</param>
        /// <param name="fromEmail"> (optional)</param>
        /// <param name="fromName"> (optional)</param>
        /// <param name="subject"> (optional)</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> DocumentEmailAsyncWithHttpInfo (string id, string toEmail = null, string fromEmail = null, string fromName = null, string subject = null)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling DocumentApi->DocumentEmail");

            var localVarPath = "/document/email";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (toEmail != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "toEmail", toEmail)); // query parameter
            if (fromEmail != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fromEmail", fromEmail)); // query parameter
            if (fromName != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "fromName", fromName)); // query parameter
            if (subject != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "subject", subject)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentEmail", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Document</returns>
        public Document DocumentId (string id)
        {
             ApiResponse<Document> localVarResponse = DocumentIdWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Document</returns>
        public ApiResponse< Document > DocumentIdWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling DocumentApi->DocumentId");

            var localVarPath = "/document/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Document>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Document) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Document)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of Document</returns>
        public async System.Threading.Tasks.Task<Document> DocumentIdAsync (string id)
        {
             ApiResponse<Document> localVarResponse = await DocumentIdAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (Document)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Document>> DocumentIdAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling DocumentApi->DocumentId");

            var localVarPath = "/document/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Document>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Document) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Document)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>DocumentListContainer</returns>
        public DocumentListContainer DocumentList (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null)
        {
             ApiResponse<DocumentListContainer> localVarResponse = DocumentListWithHttpInfo(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>ApiResponse of DocumentListContainer</returns>
        public ApiResponse< DocumentListContainer > DocumentListWithHttpInfo (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null)
        {

            var localVarPath = "/document";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (number != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "number", number)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter
            if (type1 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type1", type1)); // query parameter
            if (type2 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type2", type2)); // query parameter
            if (updateDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "updateDate", updateDate)); // query parameter
            if (account != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "account", account)); // query parameter
            if (product != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "product", product)); // query parameter
            if (productCategory != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "productCategory", productCategory)); // query parameter
            if (deleted != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "deleted", deleted)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "type", type)); // query parameter
            if (serie != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "serie", serie)); // query parameter
            if (salesman != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "salesman", salesman)); // query parameter
            if (extraFieldsExpression != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "extra_fields_expression", extraFieldsExpression)); // query parameter
            if (extraFields != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "extra_fields", extraFields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>Task of DocumentListContainer</returns>
        public async System.Threading.Tasks.Task<DocumentListContainer> DocumentListAsync (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null)
        {
             ApiResponse<DocumentListContainer> localVarResponse = await DocumentListAsyncWithHttpInfo(offset, limit, number, startDate, endDate, type1, type2, updateDate, account, product, productCategory, deleted, name, type, serie, salesman, extraFieldsExpression, extraFields);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="number"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="updateDate">ISO 8601 (optional)</param>
        /// <param name="account"> (optional)</param>
        /// <param name="product"> (optional)</param>
        /// <param name="productCategory"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="salesman"> (optional)</param>
        /// <param name="extraFieldsExpression"> (optional)</param>
        /// <param name="extraFields"> (optional)</param>
        /// <returns>Task of ApiResponse (DocumentListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentListContainer>> DocumentListAsyncWithHttpInfo (int? offset = null, int? limit = null, int? number = null, DateTime? startDate = null, DateTime? endDate = null, string type1 = null, string type2 = null, DateTime? updateDate = null, string account = null, string product = null, string productCategory = null, bool? deleted = null, string name = null, List<string> type = null, List<string> serie = null, List<string> salesman = null, string extraFieldsExpression = null, List<string> extraFields = null)
        {

            var localVarPath = "/document";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (number != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "number", number)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter
            if (type1 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type1", type1)); // query parameter
            if (type2 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type2", type2)); // query parameter
            if (updateDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "updateDate", updateDate)); // query parameter
            if (account != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "account", account)); // query parameter
            if (product != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "product", product)); // query parameter
            if (productCategory != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "productCategory", productCategory)); // query parameter
            if (deleted != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "deleted", deleted)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "type", type)); // query parameter
            if (serie != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "serie", serie)); // query parameter
            if (salesman != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "salesman", salesman)); // query parameter
            if (extraFieldsExpression != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "extra_fields_expression", extraFieldsExpression)); // query parameter
            if (extraFields != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "extra_fields", extraFields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumentList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentListContainer)));
        }

        /// <summary>
        /// List document types and series 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>DocumentTypeListContainer</returns>
        public DocumentTypeListContainer DocumenttypeList (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null)
        {
             ApiResponse<DocumentTypeListContainer> localVarResponse = DocumenttypeListWithHttpInfo(type, serie, type1, type2, userType, userId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List document types and series 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>ApiResponse of DocumentTypeListContainer</returns>
        public ApiResponse< DocumentTypeListContainer > DocumenttypeListWithHttpInfo (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null)
        {

            var localVarPath = "/document/type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (serie != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "serie", serie)); // query parameter
            if (type1 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type1", type1)); // query parameter
            if (type2 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type2", type2)); // query parameter
            if (userType != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "userType", userType)); // query parameter
            if (userId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "userId", userId)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumenttypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentTypeListContainer)));
        }

        /// <summary>
        /// List document types and series 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>Task of DocumentTypeListContainer</returns>
        public async System.Threading.Tasks.Task<DocumentTypeListContainer> DocumenttypeListAsync (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null)
        {
             ApiResponse<DocumentTypeListContainer> localVarResponse = await DocumenttypeListAsyncWithHttpInfo(type, serie, type1, type2, userType, userId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List document types and series 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="type"> (optional)</param>
        /// <param name="serie"> (optional)</param>
        /// <param name="type1"> (optional)</param>
        /// <param name="type2"> (optional)</param>
        /// <param name="userType"> (optional)</param>
        /// <param name="userId"> (optional)</param>
        /// <returns>Task of ApiResponse (DocumentTypeListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentTypeListContainer>> DocumenttypeListAsyncWithHttpInfo (string type = null, string serie = null, string type1 = null, string type2 = null, string userType = null, string userId = null)
        {

            var localVarPath = "/document/type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (serie != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "serie", serie)); // query parameter
            if (type1 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type1", type1)); // query parameter
            if (type2 != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type2", type2)); // query parameter
            if (userType != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "userType", userType)); // query parameter
            if (userId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "userId", userId)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DocumenttypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentTypeListContainer)));
        }

    }
}
