/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;

namespace IO.Swagger.Client
{
    /// <summary>
    /// API Exception
    /// </summary>
    public class ApiException : Exception
    {
        /// <summary>
        /// Gets or sets the error code (HTTP status code)
        /// </summary>
        /// <value>The error code (HTTP status code).</value>
        public int ErrorCode { get; set; }

        /// <summary>
        /// Gets or sets the error content (body json object)
        /// </summary>
        /// <value>The error content (Http response body).</value>
        public dynamic ErrorContent { get; private set; }

        /// <summary>
        /// Initializes a new instance of the <see cref="ApiException"/> class.
        /// </summary>
        public ApiException() {}

        /// <summary>
        /// Initializes a new instance of the <see cref="ApiException"/> class.
        /// </summary>
        /// <param name="errorCode">HTTP status code.</param>
        /// <param name="message">Error message.</param>
        public ApiException(int errorCode, string message) : base(message)
        {
            this.ErrorCode = errorCode;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ApiException"/> class.
        /// </summary>
        /// <param name="errorCode">HTTP status code.</param>
        /// <param name="message">Error message.</param>
        /// <param name="errorContent">Error content.</param>
        public ApiException(int errorCode, string message, dynamic errorContent = null) : base(message)
        {
            this.ErrorCode = errorCode;
            this.ErrorContent = errorContent;
        }
    }

}
