/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Account
    /// </summary>
    [DataContract]
    public partial class Account :  IEquatable<Account>, IValidatableObject
    {
        /// <summary>
        /// Defines Type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            
            /// <summary>
            /// Enum CLIENT for value: CLIENT
            /// </summary>
            [EnumMember(Value = "CLIENT")]
            CLIENT = 1,
            
            /// <summary>
            /// Enum SUPPLIER for value: SUPPLIER
            /// </summary>
            [EnumMember(Value = "SUPPLIER")]
            SUPPLIER = 2
        }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public TypeEnum? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="Account" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="name">name.</param>
        /// <param name="utlIns">utlIns.</param>
        /// <param name="dtIns">dtIns.</param>
        /// <param name="utlAlt">utlAlt.</param>
        /// <param name="dtAlt">dtAlt.</param>
        /// <param name="deleted">deleted.</param>
        /// <param name="extra">extra.</param>
        /// <param name="externalId">externalId.</param>
        /// <param name="externalSource">externalSource.</param>
        /// <param name="type">type.</param>
        /// <param name="vatNumber">vatNumber.</param>
        /// <param name="email">email.</param>
        /// <param name="phone">phone.</param>
        /// <param name="paymentTerm">paymentTerm.</param>
        /// <param name="paymentMethod">paymentMethod.</param>
        /// <param name="taxZone">taxZone.</param>
        /// <param name="taxRule">taxRule.</param>
        /// <param name="address">address.</param>
        /// <param name="salesman">salesman.</param>
        /// <param name="balance">balance.</param>
        /// <param name="currency">currency.</param>
        /// <param name="priceType">priceType.</param>
        /// <param name="products">products.</param>
        public Account(string id = default(string), string name = default(string), string utlIns = default(string), DateTime? dtIns = default(DateTime?), string utlAlt = default(string), DateTime? dtAlt = default(DateTime?), bool? deleted = default(bool?), List<Pair> extra = default(List<Pair>), string externalId = default(string), string externalSource = default(string), TypeEnum? type = default(TypeEnum?), string vatNumber = default(string), string email = default(string), string phone = default(string), PaymentTerms paymentTerm = default(PaymentTerms), PaymentMethod paymentMethod = default(PaymentMethod), TaxZone taxZone = default(TaxZone), TaxRule taxRule = default(TaxRule), List<Address> address = default(List<Address>), List<Salesman> salesman = default(List<Salesman>), decimal? balance = default(decimal?), string currency = default(string), PriceType priceType = default(PriceType), List<Product> products = default(List<Product>))
        {
            this.Id = id;
            this.Name = name;
            this.UtlIns = utlIns;
            this.DtIns = dtIns;
            this.UtlAlt = utlAlt;
            this.DtAlt = dtAlt;
            this.Deleted = deleted;
            this.Extra = extra;
            this.ExternalId = externalId;
            this.ExternalSource = externalSource;
            this.Type = type;
            this.VatNumber = vatNumber;
            this.Email = email;
            this.Phone = phone;
            this.PaymentTerm = paymentTerm;
            this.PaymentMethod = paymentMethod;
            this.TaxZone = taxZone;
            this.TaxRule = taxRule;
            this.Address = address;
            this.Salesman = salesman;
            this.Balance = balance;
            this.Currency = currency;
            this.PriceType = priceType;
            this.Products = products;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets UtlIns
        /// </summary>
        [DataMember(Name="utlIns", EmitDefaultValue=false)]
        public string UtlIns { get; set; }

        /// <summary>
        /// Gets or Sets DtIns
        /// </summary>
        [DataMember(Name="dtIns", EmitDefaultValue=false)]
        public DateTime? DtIns { get; set; }

        /// <summary>
        /// Gets or Sets UtlAlt
        /// </summary>
        [DataMember(Name="utlAlt", EmitDefaultValue=false)]
        public string UtlAlt { get; set; }

        /// <summary>
        /// Gets or Sets DtAlt
        /// </summary>
        [DataMember(Name="dtAlt", EmitDefaultValue=false)]
        public DateTime? DtAlt { get; set; }

        /// <summary>
        /// Gets or Sets Deleted
        /// </summary>
        [DataMember(Name="deleted", EmitDefaultValue=false)]
        public bool? Deleted { get; set; }

        /// <summary>
        /// Gets or Sets Extra
        /// </summary>
        [DataMember(Name="extra", EmitDefaultValue=false)]
        public List<Pair> Extra { get; set; }

        /// <summary>
        /// Gets or Sets ExternalId
        /// </summary>
        [DataMember(Name="externalId", EmitDefaultValue=false)]
        public string ExternalId { get; set; }

        /// <summary>
        /// Gets or Sets ExternalSource
        /// </summary>
        [DataMember(Name="externalSource", EmitDefaultValue=false)]
        public string ExternalSource { get; set; }


        /// <summary>
        /// Gets or Sets VatNumber
        /// </summary>
        [DataMember(Name="vatNumber", EmitDefaultValue=false)]
        public string VatNumber { get; set; }

        /// <summary>
        /// Gets or Sets Email
        /// </summary>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Gets or Sets Phone
        /// </summary>
        [DataMember(Name="phone", EmitDefaultValue=false)]
        public string Phone { get; set; }

        /// <summary>
        /// Gets or Sets PaymentTerm
        /// </summary>
        [DataMember(Name="paymentTerm", EmitDefaultValue=false)]
        public PaymentTerms PaymentTerm { get; set; }

        /// <summary>
        /// Gets or Sets PaymentMethod
        /// </summary>
        [DataMember(Name="paymentMethod", EmitDefaultValue=false)]
        public PaymentMethod PaymentMethod { get; set; }

        /// <summary>
        /// Gets or Sets TaxZone
        /// </summary>
        [DataMember(Name="taxZone", EmitDefaultValue=false)]
        public TaxZone TaxZone { get; set; }

        /// <summary>
        /// Gets or Sets TaxRule
        /// </summary>
        [DataMember(Name="taxRule", EmitDefaultValue=false)]
        public TaxRule TaxRule { get; set; }

        /// <summary>
        /// Gets or Sets Address
        /// </summary>
        [DataMember(Name="address", EmitDefaultValue=false)]
        public List<Address> Address { get; set; }

        /// <summary>
        /// Gets or Sets Salesman
        /// </summary>
        [DataMember(Name="salesman", EmitDefaultValue=false)]
        public List<Salesman> Salesman { get; set; }

        /// <summary>
        /// Gets or Sets Balance
        /// </summary>
        [DataMember(Name="balance", EmitDefaultValue=false)]
        public decimal? Balance { get; set; }

        /// <summary>
        /// Gets or Sets Currency
        /// </summary>
        [DataMember(Name="currency", EmitDefaultValue=false)]
        public string Currency { get; set; }

        /// <summary>
        /// Gets or Sets PriceType
        /// </summary>
        [DataMember(Name="priceType", EmitDefaultValue=false)]
        public PriceType PriceType { get; set; }

        /// <summary>
        /// Gets or Sets Products
        /// </summary>
        [DataMember(Name="products", EmitDefaultValue=false)]
        public List<Product> Products { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Account {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  UtlIns: ").Append(UtlIns).Append("\n");
            sb.Append("  DtIns: ").Append(DtIns).Append("\n");
            sb.Append("  UtlAlt: ").Append(UtlAlt).Append("\n");
            sb.Append("  DtAlt: ").Append(DtAlt).Append("\n");
            sb.Append("  Deleted: ").Append(Deleted).Append("\n");
            sb.Append("  Extra: ").Append(Extra).Append("\n");
            sb.Append("  ExternalId: ").Append(ExternalId).Append("\n");
            sb.Append("  ExternalSource: ").Append(ExternalSource).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  VatNumber: ").Append(VatNumber).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  Phone: ").Append(Phone).Append("\n");
            sb.Append("  PaymentTerm: ").Append(PaymentTerm).Append("\n");
            sb.Append("  PaymentMethod: ").Append(PaymentMethod).Append("\n");
            sb.Append("  TaxZone: ").Append(TaxZone).Append("\n");
            sb.Append("  TaxRule: ").Append(TaxRule).Append("\n");
            sb.Append("  Address: ").Append(Address).Append("\n");
            sb.Append("  Salesman: ").Append(Salesman).Append("\n");
            sb.Append("  Balance: ").Append(Balance).Append("\n");
            sb.Append("  Currency: ").Append(Currency).Append("\n");
            sb.Append("  PriceType: ").Append(PriceType).Append("\n");
            sb.Append("  Products: ").Append(Products).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Account);
        }

        /// <summary>
        /// Returns true if Account instances are equal
        /// </summary>
        /// <param name="input">Instance of Account to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Account input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.UtlIns == input.UtlIns ||
                    (this.UtlIns != null &&
                    this.UtlIns.Equals(input.UtlIns))
                ) && 
                (
                    this.DtIns == input.DtIns ||
                    (this.DtIns != null &&
                    this.DtIns.Equals(input.DtIns))
                ) && 
                (
                    this.UtlAlt == input.UtlAlt ||
                    (this.UtlAlt != null &&
                    this.UtlAlt.Equals(input.UtlAlt))
                ) && 
                (
                    this.DtAlt == input.DtAlt ||
                    (this.DtAlt != null &&
                    this.DtAlt.Equals(input.DtAlt))
                ) && 
                (
                    this.Deleted == input.Deleted ||
                    (this.Deleted != null &&
                    this.Deleted.Equals(input.Deleted))
                ) && 
                (
                    this.Extra == input.Extra ||
                    this.Extra != null &&
                    this.Extra.SequenceEqual(input.Extra)
                ) && 
                (
                    this.ExternalId == input.ExternalId ||
                    (this.ExternalId != null &&
                    this.ExternalId.Equals(input.ExternalId))
                ) && 
                (
                    this.ExternalSource == input.ExternalSource ||
                    (this.ExternalSource != null &&
                    this.ExternalSource.Equals(input.ExternalSource))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.VatNumber == input.VatNumber ||
                    (this.VatNumber != null &&
                    this.VatNumber.Equals(input.VatNumber))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.Phone == input.Phone ||
                    (this.Phone != null &&
                    this.Phone.Equals(input.Phone))
                ) && 
                (
                    this.PaymentTerm == input.PaymentTerm ||
                    (this.PaymentTerm != null &&
                    this.PaymentTerm.Equals(input.PaymentTerm))
                ) && 
                (
                    this.PaymentMethod == input.PaymentMethod ||
                    (this.PaymentMethod != null &&
                    this.PaymentMethod.Equals(input.PaymentMethod))
                ) && 
                (
                    this.TaxZone == input.TaxZone ||
                    (this.TaxZone != null &&
                    this.TaxZone.Equals(input.TaxZone))
                ) && 
                (
                    this.TaxRule == input.TaxRule ||
                    (this.TaxRule != null &&
                    this.TaxRule.Equals(input.TaxRule))
                ) && 
                (
                    this.Address == input.Address ||
                    this.Address != null &&
                    this.Address.SequenceEqual(input.Address)
                ) && 
                (
                    this.Salesman == input.Salesman ||
                    this.Salesman != null &&
                    this.Salesman.SequenceEqual(input.Salesman)
                ) && 
                (
                    this.Balance == input.Balance ||
                    (this.Balance != null &&
                    this.Balance.Equals(input.Balance))
                ) && 
                (
                    this.Currency == input.Currency ||
                    (this.Currency != null &&
                    this.Currency.Equals(input.Currency))
                ) && 
                (
                    this.PriceType == input.PriceType ||
                    (this.PriceType != null &&
                    this.PriceType.Equals(input.PriceType))
                ) && 
                (
                    this.Products == input.Products ||
                    this.Products != null &&
                    this.Products.SequenceEqual(input.Products)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.UtlIns != null)
                    hashCode = hashCode * 59 + this.UtlIns.GetHashCode();
                if (this.DtIns != null)
                    hashCode = hashCode * 59 + this.DtIns.GetHashCode();
                if (this.UtlAlt != null)
                    hashCode = hashCode * 59 + this.UtlAlt.GetHashCode();
                if (this.DtAlt != null)
                    hashCode = hashCode * 59 + this.DtAlt.GetHashCode();
                if (this.Deleted != null)
                    hashCode = hashCode * 59 + this.Deleted.GetHashCode();
                if (this.Extra != null)
                    hashCode = hashCode * 59 + this.Extra.GetHashCode();
                if (this.ExternalId != null)
                    hashCode = hashCode * 59 + this.ExternalId.GetHashCode();
                if (this.ExternalSource != null)
                    hashCode = hashCode * 59 + this.ExternalSource.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.VatNumber != null)
                    hashCode = hashCode * 59 + this.VatNumber.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.Phone != null)
                    hashCode = hashCode * 59 + this.Phone.GetHashCode();
                if (this.PaymentTerm != null)
                    hashCode = hashCode * 59 + this.PaymentTerm.GetHashCode();
                if (this.PaymentMethod != null)
                    hashCode = hashCode * 59 + this.PaymentMethod.GetHashCode();
                if (this.TaxZone != null)
                    hashCode = hashCode * 59 + this.TaxZone.GetHashCode();
                if (this.TaxRule != null)
                    hashCode = hashCode * 59 + this.TaxRule.GetHashCode();
                if (this.Address != null)
                    hashCode = hashCode * 59 + this.Address.GetHashCode();
                if (this.Salesman != null)
                    hashCode = hashCode * 59 + this.Salesman.GetHashCode();
                if (this.Balance != null)
                    hashCode = hashCode * 59 + this.Balance.GetHashCode();
                if (this.Currency != null)
                    hashCode = hashCode * 59 + this.Currency.GetHashCode();
                if (this.PriceType != null)
                    hashCode = hashCode * 59 + this.PriceType.GetHashCode();
                if (this.Products != null)
                    hashCode = hashCode * 59 + this.Products.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
