/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Contact
    /// </summary>
    [DataContract]
    public partial class Contact :  IEquatable<Contact>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Contact" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="name">name.</param>
        /// <param name="utlIns">utlIns.</param>
        /// <param name="dtIns">dtIns.</param>
        /// <param name="utlAlt">utlAlt.</param>
        /// <param name="dtAlt">dtAlt.</param>
        /// <param name="deleted">deleted.</param>
        /// <param name="extra">extra.</param>
        /// <param name="title">title.</param>
        /// <param name="email">email.</param>
        /// <param name="phone1">phone1.</param>
        /// <param name="phone2">phone2.</param>
        /// <param name="address">address.</param>
        /// <param name="externalId">externalId.</param>
        /// <param name="externalSource">externalSource.</param>
        /// <param name="key">key.</param>
        /// <param name="type">type.</param>
        /// <param name="accountEmail">accountEmail.</param>
        /// <param name="accountPhone1">accountPhone1.</param>
        /// <param name="accountPhone2">accountPhone2.</param>
        /// <param name="accountPosition">accountPosition.</param>
        public Contact(string id = default(string), string name = default(string), string utlIns = default(string), DateTime? dtIns = default(DateTime?), string utlAlt = default(string), DateTime? dtAlt = default(DateTime?), bool? deleted = default(bool?), List<Pair> extra = default(List<Pair>), string title = default(string), string email = default(string), string phone1 = default(string), string phone2 = default(string), Address address = default(Address), string externalId = default(string), string externalSource = default(string), string key = default(string), ContactType type = default(ContactType), string accountEmail = default(string), string accountPhone1 = default(string), string accountPhone2 = default(string), string accountPosition = default(string))
        {
            this.Id = id;
            this.Name = name;
            this.UtlIns = utlIns;
            this.DtIns = dtIns;
            this.UtlAlt = utlAlt;
            this.DtAlt = dtAlt;
            this.Deleted = deleted;
            this.Extra = extra;
            this.Title = title;
            this.Email = email;
            this.Phone1 = phone1;
            this.Phone2 = phone2;
            this.Address = address;
            this.ExternalId = externalId;
            this.ExternalSource = externalSource;
            this.Key = key;
            this.Type = type;
            this.AccountEmail = accountEmail;
            this.AccountPhone1 = accountPhone1;
            this.AccountPhone2 = accountPhone2;
            this.AccountPosition = accountPosition;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets UtlIns
        /// </summary>
        [DataMember(Name="utlIns", EmitDefaultValue=false)]
        public string UtlIns { get; set; }

        /// <summary>
        /// Gets or Sets DtIns
        /// </summary>
        [DataMember(Name="dtIns", EmitDefaultValue=false)]
        public DateTime? DtIns { get; set; }

        /// <summary>
        /// Gets or Sets UtlAlt
        /// </summary>
        [DataMember(Name="utlAlt", EmitDefaultValue=false)]
        public string UtlAlt { get; set; }

        /// <summary>
        /// Gets or Sets DtAlt
        /// </summary>
        [DataMember(Name="dtAlt", EmitDefaultValue=false)]
        public DateTime? DtAlt { get; set; }

        /// <summary>
        /// Gets or Sets Deleted
        /// </summary>
        [DataMember(Name="deleted", EmitDefaultValue=false)]
        public bool? Deleted { get; set; }

        /// <summary>
        /// Gets or Sets Extra
        /// </summary>
        [DataMember(Name="extra", EmitDefaultValue=false)]
        public List<Pair> Extra { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Email
        /// </summary>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Gets or Sets Phone1
        /// </summary>
        [DataMember(Name="phone1", EmitDefaultValue=false)]
        public string Phone1 { get; set; }

        /// <summary>
        /// Gets or Sets Phone2
        /// </summary>
        [DataMember(Name="phone2", EmitDefaultValue=false)]
        public string Phone2 { get; set; }

        /// <summary>
        /// Gets or Sets Address
        /// </summary>
        [DataMember(Name="address", EmitDefaultValue=false)]
        public Address Address { get; set; }

        /// <summary>
        /// Gets or Sets ExternalId
        /// </summary>
        [DataMember(Name="externalId", EmitDefaultValue=false)]
        public string ExternalId { get; set; }

        /// <summary>
        /// Gets or Sets ExternalSource
        /// </summary>
        [DataMember(Name="externalSource", EmitDefaultValue=false)]
        public string ExternalSource { get; set; }

        /// <summary>
        /// Gets or Sets Key
        /// </summary>
        [DataMember(Name="key", EmitDefaultValue=false)]
        public string Key { get; set; }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="type", EmitDefaultValue=false)]
        public ContactType Type { get; set; }

        /// <summary>
        /// Gets or Sets AccountEmail
        /// </summary>
        [DataMember(Name="accountEmail", EmitDefaultValue=false)]
        public string AccountEmail { get; set; }

        /// <summary>
        /// Gets or Sets AccountPhone1
        /// </summary>
        [DataMember(Name="accountPhone1", EmitDefaultValue=false)]
        public string AccountPhone1 { get; set; }

        /// <summary>
        /// Gets or Sets AccountPhone2
        /// </summary>
        [DataMember(Name="accountPhone2", EmitDefaultValue=false)]
        public string AccountPhone2 { get; set; }

        /// <summary>
        /// Gets or Sets AccountPosition
        /// </summary>
        [DataMember(Name="accountPosition", EmitDefaultValue=false)]
        public string AccountPosition { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Contact {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  UtlIns: ").Append(UtlIns).Append("\n");
            sb.Append("  DtIns: ").Append(DtIns).Append("\n");
            sb.Append("  UtlAlt: ").Append(UtlAlt).Append("\n");
            sb.Append("  DtAlt: ").Append(DtAlt).Append("\n");
            sb.Append("  Deleted: ").Append(Deleted).Append("\n");
            sb.Append("  Extra: ").Append(Extra).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  Phone1: ").Append(Phone1).Append("\n");
            sb.Append("  Phone2: ").Append(Phone2).Append("\n");
            sb.Append("  Address: ").Append(Address).Append("\n");
            sb.Append("  ExternalId: ").Append(ExternalId).Append("\n");
            sb.Append("  ExternalSource: ").Append(ExternalSource).Append("\n");
            sb.Append("  Key: ").Append(Key).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  AccountEmail: ").Append(AccountEmail).Append("\n");
            sb.Append("  AccountPhone1: ").Append(AccountPhone1).Append("\n");
            sb.Append("  AccountPhone2: ").Append(AccountPhone2).Append("\n");
            sb.Append("  AccountPosition: ").Append(AccountPosition).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Contact);
        }

        /// <summary>
        /// Returns true if Contact instances are equal
        /// </summary>
        /// <param name="input">Instance of Contact to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Contact input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.UtlIns == input.UtlIns ||
                    (this.UtlIns != null &&
                    this.UtlIns.Equals(input.UtlIns))
                ) && 
                (
                    this.DtIns == input.DtIns ||
                    (this.DtIns != null &&
                    this.DtIns.Equals(input.DtIns))
                ) && 
                (
                    this.UtlAlt == input.UtlAlt ||
                    (this.UtlAlt != null &&
                    this.UtlAlt.Equals(input.UtlAlt))
                ) && 
                (
                    this.DtAlt == input.DtAlt ||
                    (this.DtAlt != null &&
                    this.DtAlt.Equals(input.DtAlt))
                ) && 
                (
                    this.Deleted == input.Deleted ||
                    (this.Deleted != null &&
                    this.Deleted.Equals(input.Deleted))
                ) && 
                (
                    this.Extra == input.Extra ||
                    this.Extra != null &&
                    this.Extra.SequenceEqual(input.Extra)
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.Phone1 == input.Phone1 ||
                    (this.Phone1 != null &&
                    this.Phone1.Equals(input.Phone1))
                ) && 
                (
                    this.Phone2 == input.Phone2 ||
                    (this.Phone2 != null &&
                    this.Phone2.Equals(input.Phone2))
                ) && 
                (
                    this.Address == input.Address ||
                    (this.Address != null &&
                    this.Address.Equals(input.Address))
                ) && 
                (
                    this.ExternalId == input.ExternalId ||
                    (this.ExternalId != null &&
                    this.ExternalId.Equals(input.ExternalId))
                ) && 
                (
                    this.ExternalSource == input.ExternalSource ||
                    (this.ExternalSource != null &&
                    this.ExternalSource.Equals(input.ExternalSource))
                ) && 
                (
                    this.Key == input.Key ||
                    (this.Key != null &&
                    this.Key.Equals(input.Key))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.AccountEmail == input.AccountEmail ||
                    (this.AccountEmail != null &&
                    this.AccountEmail.Equals(input.AccountEmail))
                ) && 
                (
                    this.AccountPhone1 == input.AccountPhone1 ||
                    (this.AccountPhone1 != null &&
                    this.AccountPhone1.Equals(input.AccountPhone1))
                ) && 
                (
                    this.AccountPhone2 == input.AccountPhone2 ||
                    (this.AccountPhone2 != null &&
                    this.AccountPhone2.Equals(input.AccountPhone2))
                ) && 
                (
                    this.AccountPosition == input.AccountPosition ||
                    (this.AccountPosition != null &&
                    this.AccountPosition.Equals(input.AccountPosition))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.UtlIns != null)
                    hashCode = hashCode * 59 + this.UtlIns.GetHashCode();
                if (this.DtIns != null)
                    hashCode = hashCode * 59 + this.DtIns.GetHashCode();
                if (this.UtlAlt != null)
                    hashCode = hashCode * 59 + this.UtlAlt.GetHashCode();
                if (this.DtAlt != null)
                    hashCode = hashCode * 59 + this.DtAlt.GetHashCode();
                if (this.Deleted != null)
                    hashCode = hashCode * 59 + this.Deleted.GetHashCode();
                if (this.Extra != null)
                    hashCode = hashCode * 59 + this.Extra.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.Phone1 != null)
                    hashCode = hashCode * 59 + this.Phone1.GetHashCode();
                if (this.Phone2 != null)
                    hashCode = hashCode * 59 + this.Phone2.GetHashCode();
                if (this.Address != null)
                    hashCode = hashCode * 59 + this.Address.GetHashCode();
                if (this.ExternalId != null)
                    hashCode = hashCode * 59 + this.ExternalId.GetHashCode();
                if (this.ExternalSource != null)
                    hashCode = hashCode * 59 + this.ExternalSource.GetHashCode();
                if (this.Key != null)
                    hashCode = hashCode * 59 + this.Key.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.AccountEmail != null)
                    hashCode = hashCode * 59 + this.AccountEmail.GetHashCode();
                if (this.AccountPhone1 != null)
                    hashCode = hashCode * 59 + this.AccountPhone1.GetHashCode();
                if (this.AccountPhone2 != null)
                    hashCode = hashCode * 59 + this.AccountPhone2.GetHashCode();
                if (this.AccountPosition != null)
                    hashCode = hashCode * 59 + this.AccountPosition.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
