/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Employee
    /// </summary>
    [DataContract]
    public partial class Employee :  IEquatable<Employee>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Employee" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="name">name.</param>
        /// <param name="utlIns">utlIns.</param>
        /// <param name="dtIns">dtIns.</param>
        /// <param name="utlAlt">utlAlt.</param>
        /// <param name="dtAlt">dtAlt.</param>
        /// <param name="deleted">deleted.</param>
        /// <param name="extra">extra.</param>
        /// <param name="title">title.</param>
        /// <param name="email">email.</param>
        /// <param name="phone1">phone1.</param>
        /// <param name="phone2">phone2.</param>
        /// <param name="address">address.</param>
        /// <param name="externalId">externalId.</param>
        /// <param name="externalSource">externalSource.</param>
        /// <param name="gender">gender.</param>
        /// <param name="nationality">nationality.</param>
        /// <param name="birthday">birthday.</param>
        /// <param name="nationalNumber">nationalNumber.</param>
        /// <param name="taxNumber">taxNumber.</param>
        /// <param name="socialSecurityNumber">socialSecurityNumber.</param>
        /// <param name="bankNumber">bankNumber.</param>
        /// <param name="swiftBic">swiftBic.</param>
        /// <param name="contractStartDate">contractStartDate.</param>
        /// <param name="contractEndDate">contractEndDate.</param>
        /// <param name="contractResignDate">contractResignDate.</param>
        /// <param name="timeoffLeave">timeoffLeave.</param>
        /// <param name="payrolSupplement">payrolSupplement.</param>
        /// <param name="monthlyPayrolSupplement">monthlyPayrolSupplement.</param>
        /// <param name="documents">documents.</param>
        public Employee(string id = default(string), string name = default(string), string utlIns = default(string), DateTime? dtIns = default(DateTime?), string utlAlt = default(string), DateTime? dtAlt = default(DateTime?), bool? deleted = default(bool?), List<Pair> extra = default(List<Pair>), string title = default(string), string email = default(string), string phone1 = default(string), string phone2 = default(string), Address address = default(Address), string externalId = default(string), string externalSource = default(string), string gender = default(string), Country nationality = default(Country), DateTime? birthday = default(DateTime?), string nationalNumber = default(string), string taxNumber = default(string), string socialSecurityNumber = default(string), string bankNumber = default(string), string swiftBic = default(string), DateTime? contractStartDate = default(DateTime?), DateTime? contractEndDate = default(DateTime?), DateTime? contractResignDate = default(DateTime?), List<TimeOffLeave> timeoffLeave = default(List<TimeOffLeave>), List<PayrollSupplement> payrolSupplement = default(List<PayrollSupplement>), List<PayrollSupplement> monthlyPayrolSupplement = default(List<PayrollSupplement>), List<ModelFile> documents = default(List<ModelFile>))
        {
            this.Id = id;
            this.Name = name;
            this.UtlIns = utlIns;
            this.DtIns = dtIns;
            this.UtlAlt = utlAlt;
            this.DtAlt = dtAlt;
            this.Deleted = deleted;
            this.Extra = extra;
            this.Title = title;
            this.Email = email;
            this.Phone1 = phone1;
            this.Phone2 = phone2;
            this.Address = address;
            this.ExternalId = externalId;
            this.ExternalSource = externalSource;
            this.Gender = gender;
            this.Nationality = nationality;
            this.Birthday = birthday;
            this.NationalNumber = nationalNumber;
            this.TaxNumber = taxNumber;
            this.SocialSecurityNumber = socialSecurityNumber;
            this.BankNumber = bankNumber;
            this.SwiftBic = swiftBic;
            this.ContractStartDate = contractStartDate;
            this.ContractEndDate = contractEndDate;
            this.ContractResignDate = contractResignDate;
            this.TimeoffLeave = timeoffLeave;
            this.PayrolSupplement = payrolSupplement;
            this.MonthlyPayrolSupplement = monthlyPayrolSupplement;
            this.Documents = documents;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets UtlIns
        /// </summary>
        [DataMember(Name="utlIns", EmitDefaultValue=false)]
        public string UtlIns { get; set; }

        /// <summary>
        /// Gets or Sets DtIns
        /// </summary>
        [DataMember(Name="dtIns", EmitDefaultValue=false)]
        public DateTime? DtIns { get; set; }

        /// <summary>
        /// Gets or Sets UtlAlt
        /// </summary>
        [DataMember(Name="utlAlt", EmitDefaultValue=false)]
        public string UtlAlt { get; set; }

        /// <summary>
        /// Gets or Sets DtAlt
        /// </summary>
        [DataMember(Name="dtAlt", EmitDefaultValue=false)]
        public DateTime? DtAlt { get; set; }

        /// <summary>
        /// Gets or Sets Deleted
        /// </summary>
        [DataMember(Name="deleted", EmitDefaultValue=false)]
        public bool? Deleted { get; set; }

        /// <summary>
        /// Gets or Sets Extra
        /// </summary>
        [DataMember(Name="extra", EmitDefaultValue=false)]
        public List<Pair> Extra { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name="title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Email
        /// </summary>
        [DataMember(Name="email", EmitDefaultValue=false)]
        public string Email { get; set; }

        /// <summary>
        /// Gets or Sets Phone1
        /// </summary>
        [DataMember(Name="phone1", EmitDefaultValue=false)]
        public string Phone1 { get; set; }

        /// <summary>
        /// Gets or Sets Phone2
        /// </summary>
        [DataMember(Name="phone2", EmitDefaultValue=false)]
        public string Phone2 { get; set; }

        /// <summary>
        /// Gets or Sets Address
        /// </summary>
        [DataMember(Name="address", EmitDefaultValue=false)]
        public Address Address { get; set; }

        /// <summary>
        /// Gets or Sets ExternalId
        /// </summary>
        [DataMember(Name="externalId", EmitDefaultValue=false)]
        public string ExternalId { get; set; }

        /// <summary>
        /// Gets or Sets ExternalSource
        /// </summary>
        [DataMember(Name="externalSource", EmitDefaultValue=false)]
        public string ExternalSource { get; set; }

        /// <summary>
        /// Gets or Sets Gender
        /// </summary>
        [DataMember(Name="gender", EmitDefaultValue=false)]
        public string Gender { get; set; }

        /// <summary>
        /// Gets or Sets Nationality
        /// </summary>
        [DataMember(Name="nationality", EmitDefaultValue=false)]
        public Country Nationality { get; set; }

        /// <summary>
        /// Gets or Sets Birthday
        /// </summary>
        [DataMember(Name="birthday", EmitDefaultValue=false)]
        public DateTime? Birthday { get; set; }

        /// <summary>
        /// Gets or Sets NationalNumber
        /// </summary>
        [DataMember(Name="nationalNumber", EmitDefaultValue=false)]
        public string NationalNumber { get; set; }

        /// <summary>
        /// Gets or Sets TaxNumber
        /// </summary>
        [DataMember(Name="taxNumber", EmitDefaultValue=false)]
        public string TaxNumber { get; set; }

        /// <summary>
        /// Gets or Sets SocialSecurityNumber
        /// </summary>
        [DataMember(Name="socialSecurityNumber", EmitDefaultValue=false)]
        public string SocialSecurityNumber { get; set; }

        /// <summary>
        /// Gets or Sets BankNumber
        /// </summary>
        [DataMember(Name="bankNumber", EmitDefaultValue=false)]
        public string BankNumber { get; set; }

        /// <summary>
        /// Gets or Sets SwiftBic
        /// </summary>
        [DataMember(Name="swiftBic", EmitDefaultValue=false)]
        public string SwiftBic { get; set; }

        /// <summary>
        /// Gets or Sets ContractStartDate
        /// </summary>
        [DataMember(Name="contractStartDate", EmitDefaultValue=false)]
        public DateTime? ContractStartDate { get; set; }

        /// <summary>
        /// Gets or Sets ContractEndDate
        /// </summary>
        [DataMember(Name="contractEndDate", EmitDefaultValue=false)]
        public DateTime? ContractEndDate { get; set; }

        /// <summary>
        /// Gets or Sets ContractResignDate
        /// </summary>
        [DataMember(Name="contractResignDate", EmitDefaultValue=false)]
        public DateTime? ContractResignDate { get; set; }

        /// <summary>
        /// Gets or Sets TimeoffLeave
        /// </summary>
        [DataMember(Name="timeoffLeave", EmitDefaultValue=false)]
        public List<TimeOffLeave> TimeoffLeave { get; set; }

        /// <summary>
        /// Gets or Sets PayrolSupplement
        /// </summary>
        [DataMember(Name="payrolSupplement", EmitDefaultValue=false)]
        public List<PayrollSupplement> PayrolSupplement { get; set; }

        /// <summary>
        /// Gets or Sets MonthlyPayrolSupplement
        /// </summary>
        [DataMember(Name="monthlyPayrolSupplement", EmitDefaultValue=false)]
        public List<PayrollSupplement> MonthlyPayrolSupplement { get; set; }

        /// <summary>
        /// Gets or Sets Documents
        /// </summary>
        [DataMember(Name="documents", EmitDefaultValue=false)]
        public List<ModelFile> Documents { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Employee {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  UtlIns: ").Append(UtlIns).Append("\n");
            sb.Append("  DtIns: ").Append(DtIns).Append("\n");
            sb.Append("  UtlAlt: ").Append(UtlAlt).Append("\n");
            sb.Append("  DtAlt: ").Append(DtAlt).Append("\n");
            sb.Append("  Deleted: ").Append(Deleted).Append("\n");
            sb.Append("  Extra: ").Append(Extra).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  Phone1: ").Append(Phone1).Append("\n");
            sb.Append("  Phone2: ").Append(Phone2).Append("\n");
            sb.Append("  Address: ").Append(Address).Append("\n");
            sb.Append("  ExternalId: ").Append(ExternalId).Append("\n");
            sb.Append("  ExternalSource: ").Append(ExternalSource).Append("\n");
            sb.Append("  Gender: ").Append(Gender).Append("\n");
            sb.Append("  Nationality: ").Append(Nationality).Append("\n");
            sb.Append("  Birthday: ").Append(Birthday).Append("\n");
            sb.Append("  NationalNumber: ").Append(NationalNumber).Append("\n");
            sb.Append("  TaxNumber: ").Append(TaxNumber).Append("\n");
            sb.Append("  SocialSecurityNumber: ").Append(SocialSecurityNumber).Append("\n");
            sb.Append("  BankNumber: ").Append(BankNumber).Append("\n");
            sb.Append("  SwiftBic: ").Append(SwiftBic).Append("\n");
            sb.Append("  ContractStartDate: ").Append(ContractStartDate).Append("\n");
            sb.Append("  ContractEndDate: ").Append(ContractEndDate).Append("\n");
            sb.Append("  ContractResignDate: ").Append(ContractResignDate).Append("\n");
            sb.Append("  TimeoffLeave: ").Append(TimeoffLeave).Append("\n");
            sb.Append("  PayrolSupplement: ").Append(PayrolSupplement).Append("\n");
            sb.Append("  MonthlyPayrolSupplement: ").Append(MonthlyPayrolSupplement).Append("\n");
            sb.Append("  Documents: ").Append(Documents).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Employee);
        }

        /// <summary>
        /// Returns true if Employee instances are equal
        /// </summary>
        /// <param name="input">Instance of Employee to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Employee input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.UtlIns == input.UtlIns ||
                    (this.UtlIns != null &&
                    this.UtlIns.Equals(input.UtlIns))
                ) && 
                (
                    this.DtIns == input.DtIns ||
                    (this.DtIns != null &&
                    this.DtIns.Equals(input.DtIns))
                ) && 
                (
                    this.UtlAlt == input.UtlAlt ||
                    (this.UtlAlt != null &&
                    this.UtlAlt.Equals(input.UtlAlt))
                ) && 
                (
                    this.DtAlt == input.DtAlt ||
                    (this.DtAlt != null &&
                    this.DtAlt.Equals(input.DtAlt))
                ) && 
                (
                    this.Deleted == input.Deleted ||
                    (this.Deleted != null &&
                    this.Deleted.Equals(input.Deleted))
                ) && 
                (
                    this.Extra == input.Extra ||
                    this.Extra != null &&
                    this.Extra.SequenceEqual(input.Extra)
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.Phone1 == input.Phone1 ||
                    (this.Phone1 != null &&
                    this.Phone1.Equals(input.Phone1))
                ) && 
                (
                    this.Phone2 == input.Phone2 ||
                    (this.Phone2 != null &&
                    this.Phone2.Equals(input.Phone2))
                ) && 
                (
                    this.Address == input.Address ||
                    (this.Address != null &&
                    this.Address.Equals(input.Address))
                ) && 
                (
                    this.ExternalId == input.ExternalId ||
                    (this.ExternalId != null &&
                    this.ExternalId.Equals(input.ExternalId))
                ) && 
                (
                    this.ExternalSource == input.ExternalSource ||
                    (this.ExternalSource != null &&
                    this.ExternalSource.Equals(input.ExternalSource))
                ) && 
                (
                    this.Gender == input.Gender ||
                    (this.Gender != null &&
                    this.Gender.Equals(input.Gender))
                ) && 
                (
                    this.Nationality == input.Nationality ||
                    (this.Nationality != null &&
                    this.Nationality.Equals(input.Nationality))
                ) && 
                (
                    this.Birthday == input.Birthday ||
                    (this.Birthday != null &&
                    this.Birthday.Equals(input.Birthday))
                ) && 
                (
                    this.NationalNumber == input.NationalNumber ||
                    (this.NationalNumber != null &&
                    this.NationalNumber.Equals(input.NationalNumber))
                ) && 
                (
                    this.TaxNumber == input.TaxNumber ||
                    (this.TaxNumber != null &&
                    this.TaxNumber.Equals(input.TaxNumber))
                ) && 
                (
                    this.SocialSecurityNumber == input.SocialSecurityNumber ||
                    (this.SocialSecurityNumber != null &&
                    this.SocialSecurityNumber.Equals(input.SocialSecurityNumber))
                ) && 
                (
                    this.BankNumber == input.BankNumber ||
                    (this.BankNumber != null &&
                    this.BankNumber.Equals(input.BankNumber))
                ) && 
                (
                    this.SwiftBic == input.SwiftBic ||
                    (this.SwiftBic != null &&
                    this.SwiftBic.Equals(input.SwiftBic))
                ) && 
                (
                    this.ContractStartDate == input.ContractStartDate ||
                    (this.ContractStartDate != null &&
                    this.ContractStartDate.Equals(input.ContractStartDate))
                ) && 
                (
                    this.ContractEndDate == input.ContractEndDate ||
                    (this.ContractEndDate != null &&
                    this.ContractEndDate.Equals(input.ContractEndDate))
                ) && 
                (
                    this.ContractResignDate == input.ContractResignDate ||
                    (this.ContractResignDate != null &&
                    this.ContractResignDate.Equals(input.ContractResignDate))
                ) && 
                (
                    this.TimeoffLeave == input.TimeoffLeave ||
                    this.TimeoffLeave != null &&
                    this.TimeoffLeave.SequenceEqual(input.TimeoffLeave)
                ) && 
                (
                    this.PayrolSupplement == input.PayrolSupplement ||
                    this.PayrolSupplement != null &&
                    this.PayrolSupplement.SequenceEqual(input.PayrolSupplement)
                ) && 
                (
                    this.MonthlyPayrolSupplement == input.MonthlyPayrolSupplement ||
                    this.MonthlyPayrolSupplement != null &&
                    this.MonthlyPayrolSupplement.SequenceEqual(input.MonthlyPayrolSupplement)
                ) && 
                (
                    this.Documents == input.Documents ||
                    this.Documents != null &&
                    this.Documents.SequenceEqual(input.Documents)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.UtlIns != null)
                    hashCode = hashCode * 59 + this.UtlIns.GetHashCode();
                if (this.DtIns != null)
                    hashCode = hashCode * 59 + this.DtIns.GetHashCode();
                if (this.UtlAlt != null)
                    hashCode = hashCode * 59 + this.UtlAlt.GetHashCode();
                if (this.DtAlt != null)
                    hashCode = hashCode * 59 + this.DtAlt.GetHashCode();
                if (this.Deleted != null)
                    hashCode = hashCode * 59 + this.Deleted.GetHashCode();
                if (this.Extra != null)
                    hashCode = hashCode * 59 + this.Extra.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Email != null)
                    hashCode = hashCode * 59 + this.Email.GetHashCode();
                if (this.Phone1 != null)
                    hashCode = hashCode * 59 + this.Phone1.GetHashCode();
                if (this.Phone2 != null)
                    hashCode = hashCode * 59 + this.Phone2.GetHashCode();
                if (this.Address != null)
                    hashCode = hashCode * 59 + this.Address.GetHashCode();
                if (this.ExternalId != null)
                    hashCode = hashCode * 59 + this.ExternalId.GetHashCode();
                if (this.ExternalSource != null)
                    hashCode = hashCode * 59 + this.ExternalSource.GetHashCode();
                if (this.Gender != null)
                    hashCode = hashCode * 59 + this.Gender.GetHashCode();
                if (this.Nationality != null)
                    hashCode = hashCode * 59 + this.Nationality.GetHashCode();
                if (this.Birthday != null)
                    hashCode = hashCode * 59 + this.Birthday.GetHashCode();
                if (this.NationalNumber != null)
                    hashCode = hashCode * 59 + this.NationalNumber.GetHashCode();
                if (this.TaxNumber != null)
                    hashCode = hashCode * 59 + this.TaxNumber.GetHashCode();
                if (this.SocialSecurityNumber != null)
                    hashCode = hashCode * 59 + this.SocialSecurityNumber.GetHashCode();
                if (this.BankNumber != null)
                    hashCode = hashCode * 59 + this.BankNumber.GetHashCode();
                if (this.SwiftBic != null)
                    hashCode = hashCode * 59 + this.SwiftBic.GetHashCode();
                if (this.ContractStartDate != null)
                    hashCode = hashCode * 59 + this.ContractStartDate.GetHashCode();
                if (this.ContractEndDate != null)
                    hashCode = hashCode * 59 + this.ContractEndDate.GetHashCode();
                if (this.ContractResignDate != null)
                    hashCode = hashCode * 59 + this.ContractResignDate.GetHashCode();
                if (this.TimeoffLeave != null)
                    hashCode = hashCode * 59 + this.TimeoffLeave.GetHashCode();
                if (this.PayrolSupplement != null)
                    hashCode = hashCode * 59 + this.PayrolSupplement.GetHashCode();
                if (this.MonthlyPayrolSupplement != null)
                    hashCode = hashCode * 59 + this.MonthlyPayrolSupplement.GetHashCode();
                if (this.Documents != null)
                    hashCode = hashCode * 59 + this.Documents.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
