/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProductCategory
    /// </summary>
    [DataContract]
    public partial class ProductCategory :  IEquatable<ProductCategory>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProductCategory" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="name">name.</param>
        /// <param name="utlIns">utlIns.</param>
        /// <param name="dtIns">dtIns.</param>
        /// <param name="utlAlt">utlAlt.</param>
        /// <param name="dtAlt">dtAlt.</param>
        /// <param name="deleted">deleted.</param>
        /// <param name="extra">extra.</param>
        /// <param name="productCategories">productCategories.</param>
        /// <param name="parent">parent.</param>
        /// <param name="products">products.</param>
        /// <param name="labels">labels.</param>
        public ProductCategory(string id = default(string), string name = default(string), string utlIns = default(string), DateTime? dtIns = default(DateTime?), string utlAlt = default(string), DateTime? dtAlt = default(DateTime?), bool? deleted = default(bool?), List<Pair> extra = default(List<Pair>), List<ProductCategory> productCategories = default(List<ProductCategory>), ProductCategory parent = default(ProductCategory), List<Product> products = default(List<Product>), List<I18nText> labels = default(List<I18nText>))
        {
            this.Id = id;
            this.Name = name;
            this.UtlIns = utlIns;
            this.DtIns = dtIns;
            this.UtlAlt = utlAlt;
            this.DtAlt = dtAlt;
            this.Deleted = deleted;
            this.Extra = extra;
            this.ProductCategories = productCategories;
            this.Parent = parent;
            this.Products = products;
            this.Labels = labels;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets UtlIns
        /// </summary>
        [DataMember(Name="utlIns", EmitDefaultValue=false)]
        public string UtlIns { get; set; }

        /// <summary>
        /// Gets or Sets DtIns
        /// </summary>
        [DataMember(Name="dtIns", EmitDefaultValue=false)]
        public DateTime? DtIns { get; set; }

        /// <summary>
        /// Gets or Sets UtlAlt
        /// </summary>
        [DataMember(Name="utlAlt", EmitDefaultValue=false)]
        public string UtlAlt { get; set; }

        /// <summary>
        /// Gets or Sets DtAlt
        /// </summary>
        [DataMember(Name="dtAlt", EmitDefaultValue=false)]
        public DateTime? DtAlt { get; set; }

        /// <summary>
        /// Gets or Sets Deleted
        /// </summary>
        [DataMember(Name="deleted", EmitDefaultValue=false)]
        public bool? Deleted { get; set; }

        /// <summary>
        /// Gets or Sets Extra
        /// </summary>
        [DataMember(Name="extra", EmitDefaultValue=false)]
        public List<Pair> Extra { get; set; }

        /// <summary>
        /// Gets or Sets ProductCategories
        /// </summary>
        [DataMember(Name="productCategories", EmitDefaultValue=false)]
        public List<ProductCategory> ProductCategories { get; set; }

        /// <summary>
        /// Gets or Sets Parent
        /// </summary>
        [DataMember(Name="parent", EmitDefaultValue=false)]
        public ProductCategory Parent { get; set; }

        /// <summary>
        /// Gets or Sets Products
        /// </summary>
        [DataMember(Name="products", EmitDefaultValue=false)]
        public List<Product> Products { get; set; }

        /// <summary>
        /// Gets or Sets Labels
        /// </summary>
        [DataMember(Name="labels", EmitDefaultValue=false)]
        public List<I18nText> Labels { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProductCategory {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  UtlIns: ").Append(UtlIns).Append("\n");
            sb.Append("  DtIns: ").Append(DtIns).Append("\n");
            sb.Append("  UtlAlt: ").Append(UtlAlt).Append("\n");
            sb.Append("  DtAlt: ").Append(DtAlt).Append("\n");
            sb.Append("  Deleted: ").Append(Deleted).Append("\n");
            sb.Append("  Extra: ").Append(Extra).Append("\n");
            sb.Append("  ProductCategories: ").Append(ProductCategories).Append("\n");
            sb.Append("  Parent: ").Append(Parent).Append("\n");
            sb.Append("  Products: ").Append(Products).Append("\n");
            sb.Append("  Labels: ").Append(Labels).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProductCategory);
        }

        /// <summary>
        /// Returns true if ProductCategory instances are equal
        /// </summary>
        /// <param name="input">Instance of ProductCategory to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProductCategory input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.UtlIns == input.UtlIns ||
                    (this.UtlIns != null &&
                    this.UtlIns.Equals(input.UtlIns))
                ) && 
                (
                    this.DtIns == input.DtIns ||
                    (this.DtIns != null &&
                    this.DtIns.Equals(input.DtIns))
                ) && 
                (
                    this.UtlAlt == input.UtlAlt ||
                    (this.UtlAlt != null &&
                    this.UtlAlt.Equals(input.UtlAlt))
                ) && 
                (
                    this.DtAlt == input.DtAlt ||
                    (this.DtAlt != null &&
                    this.DtAlt.Equals(input.DtAlt))
                ) && 
                (
                    this.Deleted == input.Deleted ||
                    (this.Deleted != null &&
                    this.Deleted.Equals(input.Deleted))
                ) && 
                (
                    this.Extra == input.Extra ||
                    this.Extra != null &&
                    this.Extra.SequenceEqual(input.Extra)
                ) && 
                (
                    this.ProductCategories == input.ProductCategories ||
                    this.ProductCategories != null &&
                    this.ProductCategories.SequenceEqual(input.ProductCategories)
                ) && 
                (
                    this.Parent == input.Parent ||
                    (this.Parent != null &&
                    this.Parent.Equals(input.Parent))
                ) && 
                (
                    this.Products == input.Products ||
                    this.Products != null &&
                    this.Products.SequenceEqual(input.Products)
                ) && 
                (
                    this.Labels == input.Labels ||
                    this.Labels != null &&
                    this.Labels.SequenceEqual(input.Labels)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.UtlIns != null)
                    hashCode = hashCode * 59 + this.UtlIns.GetHashCode();
                if (this.DtIns != null)
                    hashCode = hashCode * 59 + this.DtIns.GetHashCode();
                if (this.UtlAlt != null)
                    hashCode = hashCode * 59 + this.UtlAlt.GetHashCode();
                if (this.DtAlt != null)
                    hashCode = hashCode * 59 + this.DtAlt.GetHashCode();
                if (this.Deleted != null)
                    hashCode = hashCode * 59 + this.Deleted.GetHashCode();
                if (this.Extra != null)
                    hashCode = hashCode * 59 + this.Extra.GetHashCode();
                if (this.ProductCategories != null)
                    hashCode = hashCode * 59 + this.ProductCategories.GetHashCode();
                if (this.Parent != null)
                    hashCode = hashCode * 59 + this.Parent.GetHashCode();
                if (this.Products != null)
                    hashCode = hashCode * 59 + this.Products.GetHashCode();
                if (this.Labels != null)
                    hashCode = hashCode * 59 + this.Labels.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
