/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Stock
    /// </summary>
    [DataContract]
    public partial class Stock :  IEquatable<Stock>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Stock" /> class.
        /// </summary>
        /// <param name="id">id.</param>
        /// <param name="name">name.</param>
        /// <param name="utlIns">utlIns.</param>
        /// <param name="dtIns">dtIns.</param>
        /// <param name="utlAlt">utlAlt.</param>
        /// <param name="dtAlt">dtAlt.</param>
        /// <param name="deleted">deleted.</param>
        /// <param name="extra">extra.</param>
        /// <param name="value">value.</param>
        /// <param name="unit">unit.</param>
        /// <param name="product">product.</param>
        /// <param name="lot">lot.</param>
        /// <param name="warehouse">warehouse.</param>
        public Stock(string id = default(string), string name = default(string), string utlIns = default(string), DateTime? dtIns = default(DateTime?), string utlAlt = default(string), DateTime? dtAlt = default(DateTime?), bool? deleted = default(bool?), List<Pair> extra = default(List<Pair>), decimal? value = default(decimal?), Unit unit = default(Unit), Product product = default(Product), Lot lot = default(Lot), Warehouse warehouse = default(Warehouse))
        {
            this.Id = id;
            this.Name = name;
            this.UtlIns = utlIns;
            this.DtIns = dtIns;
            this.UtlAlt = utlAlt;
            this.DtAlt = dtAlt;
            this.Deleted = deleted;
            this.Extra = extra;
            this.Value = value;
            this.Unit = unit;
            this.Product = product;
            this.Lot = lot;
            this.Warehouse = warehouse;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets UtlIns
        /// </summary>
        [DataMember(Name="utlIns", EmitDefaultValue=false)]
        public string UtlIns { get; set; }

        /// <summary>
        /// Gets or Sets DtIns
        /// </summary>
        [DataMember(Name="dtIns", EmitDefaultValue=false)]
        public DateTime? DtIns { get; set; }

        /// <summary>
        /// Gets or Sets UtlAlt
        /// </summary>
        [DataMember(Name="utlAlt", EmitDefaultValue=false)]
        public string UtlAlt { get; set; }

        /// <summary>
        /// Gets or Sets DtAlt
        /// </summary>
        [DataMember(Name="dtAlt", EmitDefaultValue=false)]
        public DateTime? DtAlt { get; set; }

        /// <summary>
        /// Gets or Sets Deleted
        /// </summary>
        [DataMember(Name="deleted", EmitDefaultValue=false)]
        public bool? Deleted { get; set; }

        /// <summary>
        /// Gets or Sets Extra
        /// </summary>
        [DataMember(Name="extra", EmitDefaultValue=false)]
        public List<Pair> Extra { get; set; }

        /// <summary>
        /// Gets or Sets Value
        /// </summary>
        [DataMember(Name="value", EmitDefaultValue=false)]
        public decimal? Value { get; set; }

        /// <summary>
        /// Gets or Sets Unit
        /// </summary>
        [DataMember(Name="unit", EmitDefaultValue=false)]
        public Unit Unit { get; set; }

        /// <summary>
        /// Gets or Sets Product
        /// </summary>
        [DataMember(Name="product", EmitDefaultValue=false)]
        public Product Product { get; set; }

        /// <summary>
        /// Gets or Sets Lot
        /// </summary>
        [DataMember(Name="lot", EmitDefaultValue=false)]
        public Lot Lot { get; set; }

        /// <summary>
        /// Gets or Sets Warehouse
        /// </summary>
        [DataMember(Name="warehouse", EmitDefaultValue=false)]
        public Warehouse Warehouse { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Stock {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  UtlIns: ").Append(UtlIns).Append("\n");
            sb.Append("  DtIns: ").Append(DtIns).Append("\n");
            sb.Append("  UtlAlt: ").Append(UtlAlt).Append("\n");
            sb.Append("  DtAlt: ").Append(DtAlt).Append("\n");
            sb.Append("  Deleted: ").Append(Deleted).Append("\n");
            sb.Append("  Extra: ").Append(Extra).Append("\n");
            sb.Append("  Value: ").Append(Value).Append("\n");
            sb.Append("  Unit: ").Append(Unit).Append("\n");
            sb.Append("  Product: ").Append(Product).Append("\n");
            sb.Append("  Lot: ").Append(Lot).Append("\n");
            sb.Append("  Warehouse: ").Append(Warehouse).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as Stock);
        }

        /// <summary>
        /// Returns true if Stock instances are equal
        /// </summary>
        /// <param name="input">Instance of Stock to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(Stock input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.UtlIns == input.UtlIns ||
                    (this.UtlIns != null &&
                    this.UtlIns.Equals(input.UtlIns))
                ) && 
                (
                    this.DtIns == input.DtIns ||
                    (this.DtIns != null &&
                    this.DtIns.Equals(input.DtIns))
                ) && 
                (
                    this.UtlAlt == input.UtlAlt ||
                    (this.UtlAlt != null &&
                    this.UtlAlt.Equals(input.UtlAlt))
                ) && 
                (
                    this.DtAlt == input.DtAlt ||
                    (this.DtAlt != null &&
                    this.DtAlt.Equals(input.DtAlt))
                ) && 
                (
                    this.Deleted == input.Deleted ||
                    (this.Deleted != null &&
                    this.Deleted.Equals(input.Deleted))
                ) && 
                (
                    this.Extra == input.Extra ||
                    this.Extra != null &&
                    this.Extra.SequenceEqual(input.Extra)
                ) && 
                (
                    this.Value == input.Value ||
                    (this.Value != null &&
                    this.Value.Equals(input.Value))
                ) && 
                (
                    this.Unit == input.Unit ||
                    (this.Unit != null &&
                    this.Unit.Equals(input.Unit))
                ) && 
                (
                    this.Product == input.Product ||
                    (this.Product != null &&
                    this.Product.Equals(input.Product))
                ) && 
                (
                    this.Lot == input.Lot ||
                    (this.Lot != null &&
                    this.Lot.Equals(input.Lot))
                ) && 
                (
                    this.Warehouse == input.Warehouse ||
                    (this.Warehouse != null &&
                    this.Warehouse.Equals(input.Warehouse))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.UtlIns != null)
                    hashCode = hashCode * 59 + this.UtlIns.GetHashCode();
                if (this.DtIns != null)
                    hashCode = hashCode * 59 + this.DtIns.GetHashCode();
                if (this.UtlAlt != null)
                    hashCode = hashCode * 59 + this.UtlAlt.GetHashCode();
                if (this.DtAlt != null)
                    hashCode = hashCode * 59 + this.DtAlt.GetHashCode();
                if (this.Deleted != null)
                    hashCode = hashCode * 59 + this.Deleted.GetHashCode();
                if (this.Extra != null)
                    hashCode = hashCode * 59 + this.Extra.GetHashCode();
                if (this.Value != null)
                    hashCode = hashCode * 59 + this.Value.GetHashCode();
                if (this.Unit != null)
                    hashCode = hashCode * 59 + this.Unit.GetHashCode();
                if (this.Product != null)
                    hashCode = hashCode * 59 + this.Product.GetHashCode();
                if (this.Lot != null)
                    hashCode = hashCode * 59 + this.Lot.GetHashCode();
                if (this.Warehouse != null)
                    hashCode = hashCode * 59 + this.Warehouse.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
