/* 
 * E2E.pt API
 *
 * REST API para integração empresarial com os ERP <a href=\"http://www.primaverabss.com/\" target=\"_blank\">PRIMAVERA</a>, <a href=\"http://www.sage.pt/\" target=\"_blank\">SAGE</a>, <a href=\"https://www.phcsoftware.com/\" target=\"_blank\">PHC</a> e <a href=\"https://www.artsoft.pt/\" target=\"_blank\">ARTSOFT</a>.<br/><br/>Exemplos: <a href=\"https://e2e.pt/examples\" target=\"_blank\">https://e2e.pt/examples</a><br/><br/>Documentação: <a href=\"https://e2e.pt/documentation\" target=\"_blank\">https://e2e.pt/documentation</a><br/><br/>Mais informações, preços e demonstrações em: <a href=\"https://e2e.pt\" target=\"_blank\">https://e2e.pt</a>
 *
 * OpenAPI spec version: 2.24.3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IHrApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>FileListContainer</returns>
        FileListContainer EmployeeAllFiles (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null);

        /// <summary>
        /// Get files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>ApiResponse of FileListContainer</returns>
        ApiResponse<FileListContainer> EmployeeAllFilesWithHttpInfo (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Employee</returns>
        Employee EmployeeCreate (Employee body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Employee</returns>
        ApiResponse<Employee> EmployeeCreateWithHttpInfo (Employee body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        void EmployeeDelete (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> EmployeeDeleteWithHttpInfo (string id);
        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>string</returns>
        string EmployeeFileDownloadBase64 (string id, string fileId);

        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>ApiResponse of string</returns>
        ApiResponse<string> EmployeeFileDownloadBase64WithHttpInfo (string id, string fileId);
        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>ModelFile</returns>
        ModelFile EmployeeFileDownloadBin (string id, string fileId);

        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>ApiResponse of ModelFile</returns>
        ApiResponse<ModelFile> EmployeeFileDownloadBinWithHttpInfo (string id, string fileId);
        /// <summary>
        /// Get record files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>FileListContainer</returns>
        FileListContainer EmployeeFiles (string id);

        /// <summary>
        /// Get record files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of FileListContainer</returns>
        ApiResponse<FileListContainer> EmployeeFilesWithHttpInfo (string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Employee</returns>
        Employee EmployeeId (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Employee</returns>
        ApiResponse<Employee> EmployeeIdWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>EmployeeListContainer</returns>
        EmployeeListContainer EmployeeList (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>ApiResponse of EmployeeListContainer</returns>
        ApiResponse<EmployeeListContainer> EmployeeListWithHttpInfo (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Employee</returns>
        Employee EmployeeUpdate (string id, Employee body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Employee</returns>
        ApiResponse<Employee> EmployeeUpdateWithHttpInfo (string id, Employee body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement MonthlyPayrollSupplementCreate (PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> MonthlyPayrollSupplementCreateWithHttpInfo (PayrollSupplement body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement MonthlyPayrollSupplementCreatePack (string packid, PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> MonthlyPayrollSupplementCreatePackWithHttpInfo (string packid, PayrollSupplement body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        void MonthlyPayrollSupplementDelete (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> MonthlyPayrollSupplementDeleteWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        void MonthlyPayrollSupplementDeleteExternalId (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> MonthlyPayrollSupplementDeleteExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        void MonthlyPayrollSupplementDeleteExternalIdPack (string source, string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> MonthlyPayrollSupplementDeleteExternalIdPackWithHttpInfo (string source, string id, string packid);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        void MonthlyPayrollSupplementDeletePack (string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> MonthlyPayrollSupplementDeletePackWithHttpInfo (string id, string packid);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement MonthlyPayrollSupplementExternalId (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> MonthlyPayrollSupplementExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement MonthlyPayrollSupplementId (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> MonthlyPayrollSupplementIdWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>PayrollSupplementListContainer</returns>
        PayrollSupplementListContainer MonthlyPayrollSupplementList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of PayrollSupplementListContainer</returns>
        ApiResponse<PayrollSupplementListContainer> MonthlyPayrollSupplementListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement MonthlyPayrollSupplementUpdate (string id, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> MonthlyPayrollSupplementUpdateWithHttpInfo (string id, PayrollSupplement body);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement MonthlyPayrollSupplementUpdatePack (string id, string packid, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> MonthlyPayrollSupplementUpdatePackWithHttpInfo (string id, string packid, PayrollSupplement body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement PayrollSupplementCreate (PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> PayrollSupplementCreateWithHttpInfo (PayrollSupplement body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement PayrollSupplementCreatePack (string packid, PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> PayrollSupplementCreatePackWithHttpInfo (string packid, PayrollSupplement body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        void PayrollSupplementDelete (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PayrollSupplementDeleteWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        void PayrollSupplementDeleteExternalId (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PayrollSupplementDeleteExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        void PayrollSupplementDeleteExternalIdPack (string source, string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PayrollSupplementDeleteExternalIdPackWithHttpInfo (string source, string id, string packid);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        void PayrollSupplementDeletePack (string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> PayrollSupplementDeletePackWithHttpInfo (string id, string packid);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement PayrollSupplementExternalId (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> PayrollSupplementExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement PayrollSupplementId (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> PayrollSupplementIdWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>PayrollSupplementListContainer</returns>
        PayrollSupplementListContainer PayrollSupplementList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of PayrollSupplementListContainer</returns>
        ApiResponse<PayrollSupplementListContainer> PayrollSupplementListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>PayrollSupplementTypeListContainer</returns>
        PayrollSupplementTypeListContainer PayrollSupplementTypeList ();

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of PayrollSupplementTypeListContainer</returns>
        ApiResponse<PayrollSupplementTypeListContainer> PayrollSupplementTypeListWithHttpInfo ();
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement PayrollSupplementUpdate (string id, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> PayrollSupplementUpdateWithHttpInfo (string id, PayrollSupplement body);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        PayrollSupplement PayrollSupplementUpdatePack (string id, string packid, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        ApiResponse<PayrollSupplement> PayrollSupplementUpdatePackWithHttpInfo (string id, string packid, PayrollSupplement body);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>TimeAttendance</returns>
        TimeAttendance TimeAttendanceId (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeAttendance</returns>
        ApiResponse<TimeAttendance> TimeAttendanceIdWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>TimeAttendanceListContainer</returns>
        TimeAttendanceListContainer TimeAttendanceList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of TimeAttendanceListContainer</returns>
        ApiResponse<TimeAttendanceListContainer> TimeAttendanceListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        TimeExtra TimeExtraCreate (TimeExtra body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        ApiResponse<TimeExtra> TimeExtraCreateWithHttpInfo (TimeExtra body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        TimeExtra TimeExtraCreatePack (string packid, TimeExtra body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        ApiResponse<TimeExtra> TimeExtraCreatePackWithHttpInfo (string packid, TimeExtra body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        void TimeExtraDelete (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> TimeExtraDeleteWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        void TimeExtraDeleteExternalId (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> TimeExtraDeleteExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        void TimeExtraDeleteExternalIdPack (string source, string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> TimeExtraDeleteExternalIdPackWithHttpInfo (string source, string id, string packid);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        void TimeExtraDeletePack (string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> TimeExtraDeletePackWithHttpInfo (string id, string packid);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>TimeExtra</returns>
        TimeExtra TimeExtraExternalId (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        ApiResponse<TimeExtra> TimeExtraExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>TimeExtra</returns>
        TimeExtra TimeExtraId (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        ApiResponse<TimeExtra> TimeExtraIdWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>TimeExtraListContainer</returns>
        TimeExtraListContainer TimeExtraList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of TimeExtraListContainer</returns>
        ApiResponse<TimeExtraListContainer> TimeExtraListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>TimeExtraTypeListContainer</returns>
        TimeExtraTypeListContainer TimeExtraTypeList ();

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of TimeExtraTypeListContainer</returns>
        ApiResponse<TimeExtraTypeListContainer> TimeExtraTypeListWithHttpInfo ();
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        TimeExtra TimeExtraUpdate (string id, TimeExtra body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        ApiResponse<TimeExtra> TimeExtraUpdateWithHttpInfo (string id, TimeExtra body);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        TimeExtra TimeExtraUpdatePack (string id, string packid, TimeExtra body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        ApiResponse<TimeExtra> TimeExtraUpdatePackWithHttpInfo (string id, string packid, TimeExtra body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>TimeOffLeave</returns>
        TimeOffLeave TimeOffLeaveCreate (TimeOffLeave body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        ApiResponse<TimeOffLeave> TimeOffLeaveCreateWithHttpInfo (TimeOffLeave body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        void TimeOffLeaveDelete (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> TimeOffLeaveDeleteWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        void TimeOffLeaveDeleteExternalId (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> TimeOffLeaveDeleteExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>TimeOffLeave</returns>
        TimeOffLeave TimeOffLeaveExternalId (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        ApiResponse<TimeOffLeave> TimeOffLeaveExternalIdWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>TimeOffLeave</returns>
        TimeOffLeave TimeOffLeaveId (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        ApiResponse<TimeOffLeave> TimeOffLeaveIdWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>TimeOffLeaveListContainer</returns>
        TimeOffLeaveListContainer TimeOffLeaveList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>ApiResponse of TimeOffLeaveListContainer</returns>
        ApiResponse<TimeOffLeaveListContainer> TimeOffLeaveListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>TimeOffLeave</returns>
        TimeOffLeave TimeOffLeaveUpdate (string id, TimeOffLeave body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        ApiResponse<TimeOffLeave> TimeOffLeaveUpdateWithHttpInfo (string id, TimeOffLeave body);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>TimeOffLeaveTypeListContainer</returns>
        TimeOffLeaveTypeListContainer TimeOffLeavetypeList ();

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of TimeOffLeaveTypeListContainer</returns>
        ApiResponse<TimeOffLeaveTypeListContainer> TimeOffLeavetypeListWithHttpInfo ();
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>Task of FileListContainer</returns>
        System.Threading.Tasks.Task<FileListContainer> EmployeeAllFilesAsync (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null);

        /// <summary>
        /// Get files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>Task of ApiResponse (FileListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<FileListContainer>> EmployeeAllFilesAsyncWithHttpInfo (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of Employee</returns>
        System.Threading.Tasks.Task<Employee> EmployeeCreateAsync (Employee body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Employee)</returns>
        System.Threading.Tasks.Task<ApiResponse<Employee>> EmployeeCreateAsyncWithHttpInfo (Employee body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task EmployeeDeleteAsync (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> EmployeeDeleteAsyncWithHttpInfo (string id);
        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of string</returns>
        System.Threading.Tasks.Task<string> EmployeeFileDownloadBase64Async (string id, string fileId);

        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of ApiResponse (string)</returns>
        System.Threading.Tasks.Task<ApiResponse<string>> EmployeeFileDownloadBase64AsyncWithHttpInfo (string id, string fileId);
        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of ModelFile</returns>
        System.Threading.Tasks.Task<ModelFile> EmployeeFileDownloadBinAsync (string id, string fileId);

        /// <summary>
        /// Get record file
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of ApiResponse (ModelFile)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelFile>> EmployeeFileDownloadBinAsyncWithHttpInfo (string id, string fileId);
        /// <summary>
        /// Get record files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of FileListContainer</returns>
        System.Threading.Tasks.Task<FileListContainer> EmployeeFilesAsync (string id);

        /// <summary>
        /// Get record files
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (FileListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<FileListContainer>> EmployeeFilesAsyncWithHttpInfo (string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of Employee</returns>
        System.Threading.Tasks.Task<Employee> EmployeeIdAsync (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (Employee)</returns>
        System.Threading.Tasks.Task<ApiResponse<Employee>> EmployeeIdAsyncWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>Task of EmployeeListContainer</returns>
        System.Threading.Tasks.Task<EmployeeListContainer> EmployeeListAsync (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>Task of ApiResponse (EmployeeListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<EmployeeListContainer>> EmployeeListAsyncWithHttpInfo (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of Employee</returns>
        System.Threading.Tasks.Task<Employee> EmployeeUpdateAsync (string id, Employee body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Employee)</returns>
        System.Threading.Tasks.Task<ApiResponse<Employee>> EmployeeUpdateAsyncWithHttpInfo (string id, Employee body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementCreateAsync (PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementCreateAsyncWithHttpInfo (PayrollSupplement body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementCreatePackAsync (string packid, PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementCreatePackAsyncWithHttpInfo (string packid, PayrollSupplement body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task MonthlyPayrollSupplementDeleteAsync (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeleteAsyncWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task MonthlyPayrollSupplementDeleteExternalIdAsync (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeleteExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task MonthlyPayrollSupplementDeleteExternalIdPackAsync (string source, string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeleteExternalIdPackAsyncWithHttpInfo (string source, string id, string packid);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task MonthlyPayrollSupplementDeletePackAsync (string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeletePackAsyncWithHttpInfo (string id, string packid);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementExternalIdAsync (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementIdAsync (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementIdAsyncWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of PayrollSupplementListContainer</returns>
        System.Threading.Tasks.Task<PayrollSupplementListContainer> MonthlyPayrollSupplementListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (PayrollSupplementListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplementListContainer>> MonthlyPayrollSupplementListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementUpdateAsync (string id, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementUpdateAsyncWithHttpInfo (string id, PayrollSupplement body);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementUpdatePackAsync (string id, string packid, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementUpdatePackAsyncWithHttpInfo (string id, string packid, PayrollSupplement body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementCreateAsync (PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementCreateAsyncWithHttpInfo (PayrollSupplement body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementCreatePackAsync (string packid, PayrollSupplement body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementCreatePackAsyncWithHttpInfo (string packid, PayrollSupplement body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PayrollSupplementDeleteAsync (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeleteAsyncWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PayrollSupplementDeleteExternalIdAsync (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeleteExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PayrollSupplementDeleteExternalIdPackAsync (string source, string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeleteExternalIdPackAsyncWithHttpInfo (string source, string id, string packid);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task PayrollSupplementDeletePackAsync (string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeletePackAsyncWithHttpInfo (string id, string packid);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementExternalIdAsync (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementIdAsync (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementIdAsyncWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of PayrollSupplementListContainer</returns>
        System.Threading.Tasks.Task<PayrollSupplementListContainer> PayrollSupplementListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (PayrollSupplementListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplementListContainer>> PayrollSupplementListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of PayrollSupplementTypeListContainer</returns>
        System.Threading.Tasks.Task<PayrollSupplementTypeListContainer> PayrollSupplementTypeListAsync ();

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (PayrollSupplementTypeListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplementTypeListContainer>> PayrollSupplementTypeListAsyncWithHttpInfo ();
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementUpdateAsync (string id, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementUpdateAsyncWithHttpInfo (string id, PayrollSupplement body);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementUpdatePackAsync (string id, string packid, PayrollSupplement body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementUpdatePackAsyncWithHttpInfo (string id, string packid, PayrollSupplement body);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of TimeAttendance</returns>
        System.Threading.Tasks.Task<TimeAttendance> TimeAttendanceIdAsync (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeAttendance)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeAttendance>> TimeAttendanceIdAsyncWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of TimeAttendanceListContainer</returns>
        System.Threading.Tasks.Task<TimeAttendanceListContainer> TimeAttendanceListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (TimeAttendanceListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeAttendanceListContainer>> TimeAttendanceListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        System.Threading.Tasks.Task<TimeExtra> TimeExtraCreateAsync (TimeExtra body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraCreateAsyncWithHttpInfo (TimeExtra body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        System.Threading.Tasks.Task<TimeExtra> TimeExtraCreatePackAsync (string packid, TimeExtra body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraCreatePackAsyncWithHttpInfo (string packid, TimeExtra body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task TimeExtraDeleteAsync (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeleteAsyncWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task TimeExtraDeleteExternalIdAsync (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeleteExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task TimeExtraDeleteExternalIdPackAsync (string source, string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeleteExternalIdPackAsyncWithHttpInfo (string source, string id, string packid);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task TimeExtraDeletePackAsync (string id, string packid);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeletePackAsyncWithHttpInfo (string id, string packid);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of TimeExtra</returns>
        System.Threading.Tasks.Task<TimeExtra> TimeExtraExternalIdAsync (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of TimeExtra</returns>
        System.Threading.Tasks.Task<TimeExtra> TimeExtraIdAsync (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraIdAsyncWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of TimeExtraListContainer</returns>
        System.Threading.Tasks.Task<TimeExtraListContainer> TimeExtraListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (TimeExtraListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtraListContainer>> TimeExtraListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of TimeExtraTypeListContainer</returns>
        System.Threading.Tasks.Task<TimeExtraTypeListContainer> TimeExtraTypeListAsync ();

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (TimeExtraTypeListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtraTypeListContainer>> TimeExtraTypeListAsyncWithHttpInfo ();
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        System.Threading.Tasks.Task<TimeExtra> TimeExtraUpdateAsync (string id, TimeExtra body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraUpdateAsyncWithHttpInfo (string id, TimeExtra body);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        System.Threading.Tasks.Task<TimeExtra> TimeExtraUpdatePackAsync (string id, string packid, TimeExtra body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraUpdatePackAsyncWithHttpInfo (string id, string packid, TimeExtra body);
        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of TimeOffLeave</returns>
        System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveCreateAsync (TimeOffLeave body);

        /// <summary>
        /// Create record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveCreateAsyncWithHttpInfo (TimeOffLeave body);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task TimeOffLeaveDeleteAsync (string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> TimeOffLeaveDeleteAsyncWithHttpInfo (string id);
        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task TimeOffLeaveDeleteExternalIdAsync (string source, string id);

        /// <summary>
        /// Delete record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> TimeOffLeaveDeleteExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of TimeOffLeave</returns>
        System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveExternalIdAsync (string source, string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveExternalIdAsyncWithHttpInfo (string source, string id);
        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of TimeOffLeave</returns>
        System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveIdAsync (string id);

        /// <summary>
        /// Get record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveIdAsyncWithHttpInfo (string id);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>Task of TimeOffLeaveListContainer</returns>
        System.Threading.Tasks.Task<TimeOffLeaveListContainer> TimeOffLeaveListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null);

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>Task of ApiResponse (TimeOffLeaveListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeOffLeaveListContainer>> TimeOffLeaveListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null);
        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeOffLeave</returns>
        System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveUpdateAsync (string id, TimeOffLeave body);

        /// <summary>
        /// Update record
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveUpdateAsyncWithHttpInfo (string id, TimeOffLeave body);
        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of TimeOffLeaveTypeListContainer</returns>
        System.Threading.Tasks.Task<TimeOffLeaveTypeListContainer> TimeOffLeavetypeListAsync ();

        /// <summary>
        /// List records
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (TimeOffLeaveTypeListContainer)</returns>
        System.Threading.Tasks.Task<ApiResponse<TimeOffLeaveTypeListContainer>> TimeOffLeavetypeListAsyncWithHttpInfo ();
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class HrApi : IHrApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="HrApi"/> class.
        /// </summary>
        /// <returns></returns>
        public HrApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="HrApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public HrApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>FileListContainer</returns>
        public FileListContainer EmployeeAllFiles (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null)
        {
             ApiResponse<FileListContainer> localVarResponse = EmployeeAllFilesWithHttpInfo(offset, limit, hrFileType, employeeId, employeeDeleted, start, end);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>ApiResponse of FileListContainer</returns>
        public ApiResponse< FileListContainer > EmployeeAllFilesWithHttpInfo (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null)
        {

            var localVarPath = "/hr/employee/files";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (hrFileType != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hr_file_type", hrFileType)); // query parameter
            if (employeeId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee_id", employeeId)); // query parameter
            if (employeeDeleted != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee_deleted", employeeDeleted)); // query parameter
            if (start != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "start", start)); // query parameter
            if (end != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "end", end)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeAllFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<FileListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FileListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(FileListContainer)));
        }

        /// <summary>
        /// Get files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>Task of FileListContainer</returns>
        public async System.Threading.Tasks.Task<FileListContainer> EmployeeAllFilesAsync (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null)
        {
             ApiResponse<FileListContainer> localVarResponse = await EmployeeAllFilesAsyncWithHttpInfo(offset, limit, hrFileType, employeeId, employeeDeleted, start, end);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="hrFileType"> (optional)</param>
        /// <param name="employeeId"> (optional)</param>
        /// <param name="employeeDeleted"> (optional)</param>
        /// <param name="start"> (optional)</param>
        /// <param name="end"> (optional)</param>
        /// <returns>Task of ApiResponse (FileListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<FileListContainer>> EmployeeAllFilesAsyncWithHttpInfo (int? offset = null, int? limit = null, string hrFileType = null, string employeeId = null, bool? employeeDeleted = null, DateTime? start = null, DateTime? end = null)
        {

            var localVarPath = "/hr/employee/files";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (hrFileType != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "hr_file_type", hrFileType)); // query parameter
            if (employeeId != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee_id", employeeId)); // query parameter
            if (employeeDeleted != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee_deleted", employeeDeleted)); // query parameter
            if (start != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "start", start)); // query parameter
            if (end != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "end", end)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeAllFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<FileListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FileListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(FileListContainer)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Employee</returns>
        public Employee EmployeeCreate (Employee body)
        {
             ApiResponse<Employee> localVarResponse = EmployeeCreateWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Employee</returns>
        public ApiResponse< Employee > EmployeeCreateWithHttpInfo (Employee body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->EmployeeCreate");

            var localVarPath = "/hr/employee";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Employee>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Employee) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Employee)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of Employee</returns>
        public async System.Threading.Tasks.Task<Employee> EmployeeCreateAsync (Employee body)
        {
             ApiResponse<Employee> localVarResponse = await EmployeeCreateAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Employee)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Employee>> EmployeeCreateAsyncWithHttpInfo (Employee body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->EmployeeCreate");

            var localVarPath = "/hr/employee";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Employee>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Employee) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Employee)));
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        public void EmployeeDelete (string id)
        {
             EmployeeDeleteWithHttpInfo(id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> EmployeeDeleteWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeDelete");

            var localVarPath = "/hr/employee/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task EmployeeDeleteAsync (string id)
        {
             await EmployeeDeleteAsyncWithHttpInfo(id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> EmployeeDeleteAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeDelete");

            var localVarPath = "/hr/employee/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>string</returns>
        public string EmployeeFileDownloadBase64 (string id, string fileId)
        {
             ApiResponse<string> localVarResponse = EmployeeFileDownloadBase64WithHttpInfo(id, fileId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>ApiResponse of string</returns>
        public ApiResponse< string > EmployeeFileDownloadBase64WithHttpInfo (string id, string fileId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeFileDownloadBase64");
            // verify the required parameter 'fileId' is set
            if (fileId == null)
                throw new ApiException(400, "Missing required parameter 'fileId' when calling HrApi->EmployeeFileDownloadBase64");

            var localVarPath = "/hr/employee/id/{id}/file/{fileId}/base64";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "text/plain"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (fileId != null) localVarPathParams.Add("fileId", this.Configuration.ApiClient.ParameterToString(fileId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeFileDownloadBase64", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of string</returns>
        public async System.Threading.Tasks.Task<string> EmployeeFileDownloadBase64Async (string id, string fileId)
        {
             ApiResponse<string> localVarResponse = await EmployeeFileDownloadBase64AsyncWithHttpInfo(id, fileId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of ApiResponse (string)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<string>> EmployeeFileDownloadBase64AsyncWithHttpInfo (string id, string fileId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeFileDownloadBase64");
            // verify the required parameter 'fileId' is set
            if (fileId == null)
                throw new ApiException(400, "Missing required parameter 'fileId' when calling HrApi->EmployeeFileDownloadBase64");

            var localVarPath = "/hr/employee/id/{id}/file/{fileId}/base64";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "text/plain"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (fileId != null) localVarPathParams.Add("fileId", this.Configuration.ApiClient.ParameterToString(fileId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeFileDownloadBase64", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<string>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (string) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(string)));
        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>ModelFile</returns>
        public ModelFile EmployeeFileDownloadBin (string id, string fileId)
        {
             ApiResponse<ModelFile> localVarResponse = EmployeeFileDownloadBinWithHttpInfo(id, fileId);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>ApiResponse of ModelFile</returns>
        public ApiResponse< ModelFile > EmployeeFileDownloadBinWithHttpInfo (string id, string fileId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeFileDownloadBin");
            // verify the required parameter 'fileId' is set
            if (fileId == null)
                throw new ApiException(400, "Missing required parameter 'fileId' when calling HrApi->EmployeeFileDownloadBin");

            var localVarPath = "/hr/employee/id/{id}/file/{fileId}/bin";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/octet-stream"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (fileId != null) localVarPathParams.Add("fileId", this.Configuration.ApiClient.ParameterToString(fileId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeFileDownloadBin", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelFile>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelFile) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelFile)));
        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of ModelFile</returns>
        public async System.Threading.Tasks.Task<ModelFile> EmployeeFileDownloadBinAsync (string id, string fileId)
        {
             ApiResponse<ModelFile> localVarResponse = await EmployeeFileDownloadBinAsyncWithHttpInfo(id, fileId);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record file 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="fileId"></param>
        /// <returns>Task of ApiResponse (ModelFile)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ModelFile>> EmployeeFileDownloadBinAsyncWithHttpInfo (string id, string fileId)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeFileDownloadBin");
            // verify the required parameter 'fileId' is set
            if (fileId == null)
                throw new ApiException(400, "Missing required parameter 'fileId' when calling HrApi->EmployeeFileDownloadBin");

            var localVarPath = "/hr/employee/id/{id}/file/{fileId}/bin";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/octet-stream"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (fileId != null) localVarPathParams.Add("fileId", this.Configuration.ApiClient.ParameterToString(fileId)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeFileDownloadBin", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelFile>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelFile) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelFile)));
        }

        /// <summary>
        /// Get record files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>FileListContainer</returns>
        public FileListContainer EmployeeFiles (string id)
        {
             ApiResponse<FileListContainer> localVarResponse = EmployeeFilesWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of FileListContainer</returns>
        public ApiResponse< FileListContainer > EmployeeFilesWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeFiles");

            var localVarPath = "/hr/employee/id/{id}/file";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<FileListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FileListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(FileListContainer)));
        }

        /// <summary>
        /// Get record files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of FileListContainer</returns>
        public async System.Threading.Tasks.Task<FileListContainer> EmployeeFilesAsync (string id)
        {
             ApiResponse<FileListContainer> localVarResponse = await EmployeeFilesAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record files 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (FileListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<FileListContainer>> EmployeeFilesAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeFiles");

            var localVarPath = "/hr/employee/id/{id}/file";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<FileListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (FileListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(FileListContainer)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Employee</returns>
        public Employee EmployeeId (string id)
        {
             ApiResponse<Employee> localVarResponse = EmployeeIdWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Employee</returns>
        public ApiResponse< Employee > EmployeeIdWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeId");

            var localVarPath = "/hr/employee/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Employee>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Employee) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Employee)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of Employee</returns>
        public async System.Threading.Tasks.Task<Employee> EmployeeIdAsync (string id)
        {
             ApiResponse<Employee> localVarResponse = await EmployeeIdAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (Employee)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Employee>> EmployeeIdAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeId");

            var localVarPath = "/hr/employee/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Employee>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Employee) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Employee)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>EmployeeListContainer</returns>
        public EmployeeListContainer EmployeeList (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null)
        {
             ApiResponse<EmployeeListContainer> localVarResponse = EmployeeListWithHttpInfo(offset, limit, name, nationalNumber, taxNumber, email, deleted, ids);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>ApiResponse of EmployeeListContainer</returns>
        public ApiResponse< EmployeeListContainer > EmployeeListWithHttpInfo (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null)
        {

            var localVarPath = "/hr/employee";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (nationalNumber != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "nationalNumber", nationalNumber)); // query parameter
            if (taxNumber != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "taxNumber", taxNumber)); // query parameter
            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (deleted != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "deleted", deleted)); // query parameter
            if (ids != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "ids", ids)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<EmployeeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (EmployeeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(EmployeeListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>Task of EmployeeListContainer</returns>
        public async System.Threading.Tasks.Task<EmployeeListContainer> EmployeeListAsync (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null)
        {
             ApiResponse<EmployeeListContainer> localVarResponse = await EmployeeListAsyncWithHttpInfo(offset, limit, name, nationalNumber, taxNumber, email, deleted, ids);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="name"> (optional)</param>
        /// <param name="nationalNumber"> (optional)</param>
        /// <param name="taxNumber"> (optional)</param>
        /// <param name="email"> (optional)</param>
        /// <param name="deleted"> (optional)</param>
        /// <param name="ids"> (optional)</param>
        /// <returns>Task of ApiResponse (EmployeeListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<EmployeeListContainer>> EmployeeListAsyncWithHttpInfo (int? offset = null, int? limit = null, string name = null, string nationalNumber = null, string taxNumber = null, string email = null, bool? deleted = null, List<string> ids = null)
        {

            var localVarPath = "/hr/employee";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (name != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "name", name)); // query parameter
            if (nationalNumber != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "nationalNumber", nationalNumber)); // query parameter
            if (taxNumber != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "taxNumber", taxNumber)); // query parameter
            if (email != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "email", email)); // query parameter
            if (deleted != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "deleted", deleted)); // query parameter
            if (ids != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("multi", "ids", ids)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<EmployeeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (EmployeeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(EmployeeListContainer)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Employee</returns>
        public Employee EmployeeUpdate (string id, Employee body)
        {
             ApiResponse<Employee> localVarResponse = EmployeeUpdateWithHttpInfo(id, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of Employee</returns>
        public ApiResponse< Employee > EmployeeUpdateWithHttpInfo (string id, Employee body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->EmployeeUpdate");

            var localVarPath = "/hr/employee/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Employee>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Employee) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Employee)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of Employee</returns>
        public async System.Threading.Tasks.Task<Employee> EmployeeUpdateAsync (string id, Employee body)
        {
             ApiResponse<Employee> localVarResponse = await EmployeeUpdateAsyncWithHttpInfo(id, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (Employee)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Employee>> EmployeeUpdateAsyncWithHttpInfo (string id, Employee body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->EmployeeUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->EmployeeUpdate");

            var localVarPath = "/hr/employee/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("EmployeeUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Employee>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (Employee) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(Employee)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement MonthlyPayrollSupplementCreate (PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = MonthlyPayrollSupplementCreateWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > MonthlyPayrollSupplementCreateWithHttpInfo (PayrollSupplement body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementCreate");

            var localVarPath = "/hr/monthly_payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementCreateAsync (PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await MonthlyPayrollSupplementCreateAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementCreateAsyncWithHttpInfo (PayrollSupplement body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementCreate");

            var localVarPath = "/hr/monthly_payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement MonthlyPayrollSupplementCreatePack (string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = MonthlyPayrollSupplementCreatePackWithHttpInfo(packid, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > MonthlyPayrollSupplementCreatePackWithHttpInfo (string packid, PayrollSupplement body)
        {
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementCreatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementCreatePack");

            var localVarPath = "/hr/monthly_payroll_supplement/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementCreatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementCreatePackAsync (string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await MonthlyPayrollSupplementCreatePackAsyncWithHttpInfo(packid, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementCreatePackAsyncWithHttpInfo (string packid, PayrollSupplement body)
        {
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementCreatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementCreatePack");

            var localVarPath = "/hr/monthly_payroll_supplement/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementCreatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        public void MonthlyPayrollSupplementDelete (string id)
        {
             MonthlyPayrollSupplementDeleteWithHttpInfo(id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> MonthlyPayrollSupplementDeleteWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDelete");

            var localVarPath = "/hr/monthly_payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task MonthlyPayrollSupplementDeleteAsync (string id)
        {
             await MonthlyPayrollSupplementDeleteAsyncWithHttpInfo(id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeleteAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDelete");

            var localVarPath = "/hr/monthly_payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        public void MonthlyPayrollSupplementDeleteExternalId (string source, string id)
        {
             MonthlyPayrollSupplementDeleteExternalIdWithHttpInfo(source, id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> MonthlyPayrollSupplementDeleteExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->MonthlyPayrollSupplementDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDeleteExternalId");

            var localVarPath = "/hr/monthly_payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task MonthlyPayrollSupplementDeleteExternalIdAsync (string source, string id)
        {
             await MonthlyPayrollSupplementDeleteExternalIdAsyncWithHttpInfo(source, id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeleteExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->MonthlyPayrollSupplementDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDeleteExternalId");

            var localVarPath = "/hr/monthly_payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        public void MonthlyPayrollSupplementDeleteExternalIdPack (string source, string id, string packid)
        {
             MonthlyPayrollSupplementDeleteExternalIdPackWithHttpInfo(source, id, packid);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> MonthlyPayrollSupplementDeleteExternalIdPackWithHttpInfo (string source, string id, string packid)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->MonthlyPayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementDeleteExternalIdPack");

            var localVarPath = "/hr/monthly_payroll_supplement/external/{source}/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDeleteExternalIdPack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task MonthlyPayrollSupplementDeleteExternalIdPackAsync (string source, string id, string packid)
        {
             await MonthlyPayrollSupplementDeleteExternalIdPackAsyncWithHttpInfo(source, id, packid);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeleteExternalIdPackAsyncWithHttpInfo (string source, string id, string packid)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->MonthlyPayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementDeleteExternalIdPack");

            var localVarPath = "/hr/monthly_payroll_supplement/external/{source}/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDeleteExternalIdPack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        public void MonthlyPayrollSupplementDeletePack (string id, string packid)
        {
             MonthlyPayrollSupplementDeletePackWithHttpInfo(id, packid);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> MonthlyPayrollSupplementDeletePackWithHttpInfo (string id, string packid)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDeletePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementDeletePack");

            var localVarPath = "/hr/monthly_payroll_supplement/id/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDeletePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task MonthlyPayrollSupplementDeletePackAsync (string id, string packid)
        {
             await MonthlyPayrollSupplementDeletePackAsyncWithHttpInfo(id, packid);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> MonthlyPayrollSupplementDeletePackAsyncWithHttpInfo (string id, string packid)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementDeletePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementDeletePack");

            var localVarPath = "/hr/monthly_payroll_supplement/id/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementDeletePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement MonthlyPayrollSupplementExternalId (string source, string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = MonthlyPayrollSupplementExternalIdWithHttpInfo(source, id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > MonthlyPayrollSupplementExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->MonthlyPayrollSupplementExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementExternalId");

            var localVarPath = "/hr/monthly_payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementExternalIdAsync (string source, string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await MonthlyPayrollSupplementExternalIdAsyncWithHttpInfo(source, id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->MonthlyPayrollSupplementExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementExternalId");

            var localVarPath = "/hr/monthly_payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement MonthlyPayrollSupplementId (string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = MonthlyPayrollSupplementIdWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > MonthlyPayrollSupplementIdWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementId");

            var localVarPath = "/hr/monthly_payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementIdAsync (string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await MonthlyPayrollSupplementIdAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementIdAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementId");

            var localVarPath = "/hr/monthly_payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>PayrollSupplementListContainer</returns>
        public PayrollSupplementListContainer MonthlyPayrollSupplementList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<PayrollSupplementListContainer> localVarResponse = MonthlyPayrollSupplementListWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of PayrollSupplementListContainer</returns>
        public ApiResponse< PayrollSupplementListContainer > MonthlyPayrollSupplementListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/monthly_payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplementListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplementListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplementListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of PayrollSupplementListContainer</returns>
        public async System.Threading.Tasks.Task<PayrollSupplementListContainer> MonthlyPayrollSupplementListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<PayrollSupplementListContainer> localVarResponse = await MonthlyPayrollSupplementListAsyncWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (PayrollSupplementListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplementListContainer>> MonthlyPayrollSupplementListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/monthly_payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplementListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplementListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplementListContainer)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement MonthlyPayrollSupplementUpdate (string id, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = MonthlyPayrollSupplementUpdateWithHttpInfo(id, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > MonthlyPayrollSupplementUpdateWithHttpInfo (string id, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementUpdate");

            var localVarPath = "/hr/monthly_payroll_supplement/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementUpdateAsync (string id, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await MonthlyPayrollSupplementUpdateAsyncWithHttpInfo(id, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementUpdateAsyncWithHttpInfo (string id, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementUpdate");

            var localVarPath = "/hr/monthly_payroll_supplement/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement MonthlyPayrollSupplementUpdatePack (string id, string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = MonthlyPayrollSupplementUpdatePackWithHttpInfo(id, packid, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > MonthlyPayrollSupplementUpdatePackWithHttpInfo (string id, string packid, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementUpdatePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementUpdatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementUpdatePack");

            var localVarPath = "/hr/monthly_payroll_supplement/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementUpdatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> MonthlyPayrollSupplementUpdatePackAsync (string id, string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await MonthlyPayrollSupplementUpdatePackAsyncWithHttpInfo(id, packid, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> MonthlyPayrollSupplementUpdatePackAsyncWithHttpInfo (string id, string packid, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->MonthlyPayrollSupplementUpdatePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->MonthlyPayrollSupplementUpdatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->MonthlyPayrollSupplementUpdatePack");

            var localVarPath = "/hr/monthly_payroll_supplement/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("MonthlyPayrollSupplementUpdatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement PayrollSupplementCreate (PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = PayrollSupplementCreateWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > PayrollSupplementCreateWithHttpInfo (PayrollSupplement body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementCreate");

            var localVarPath = "/hr/payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementCreateAsync (PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await PayrollSupplementCreateAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementCreateAsyncWithHttpInfo (PayrollSupplement body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementCreate");

            var localVarPath = "/hr/payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement PayrollSupplementCreatePack (string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = PayrollSupplementCreatePackWithHttpInfo(packid, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > PayrollSupplementCreatePackWithHttpInfo (string packid, PayrollSupplement body)
        {
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementCreatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementCreatePack");

            var localVarPath = "/hr/payroll_supplement/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementCreatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementCreatePackAsync (string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await PayrollSupplementCreatePackAsyncWithHttpInfo(packid, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementCreatePackAsyncWithHttpInfo (string packid, PayrollSupplement body)
        {
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementCreatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementCreatePack");

            var localVarPath = "/hr/payroll_supplement/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementCreatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        public void PayrollSupplementDelete (string id)
        {
             PayrollSupplementDeleteWithHttpInfo(id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PayrollSupplementDeleteWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDelete");

            var localVarPath = "/hr/payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PayrollSupplementDeleteAsync (string id)
        {
             await PayrollSupplementDeleteAsyncWithHttpInfo(id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeleteAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDelete");

            var localVarPath = "/hr/payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        public void PayrollSupplementDeleteExternalId (string source, string id)
        {
             PayrollSupplementDeleteExternalIdWithHttpInfo(source, id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PayrollSupplementDeleteExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->PayrollSupplementDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDeleteExternalId");

            var localVarPath = "/hr/payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PayrollSupplementDeleteExternalIdAsync (string source, string id)
        {
             await PayrollSupplementDeleteExternalIdAsyncWithHttpInfo(source, id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeleteExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->PayrollSupplementDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDeleteExternalId");

            var localVarPath = "/hr/payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        public void PayrollSupplementDeleteExternalIdPack (string source, string id, string packid)
        {
             PayrollSupplementDeleteExternalIdPackWithHttpInfo(source, id, packid);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PayrollSupplementDeleteExternalIdPackWithHttpInfo (string source, string id, string packid)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->PayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementDeleteExternalIdPack");

            var localVarPath = "/hr/payroll_supplement/external/{source}/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDeleteExternalIdPack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PayrollSupplementDeleteExternalIdPackAsync (string source, string id, string packid)
        {
             await PayrollSupplementDeleteExternalIdPackAsyncWithHttpInfo(source, id, packid);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeleteExternalIdPackAsyncWithHttpInfo (string source, string id, string packid)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->PayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDeleteExternalIdPack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementDeleteExternalIdPack");

            var localVarPath = "/hr/payroll_supplement/external/{source}/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDeleteExternalIdPack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        public void PayrollSupplementDeletePack (string id, string packid)
        {
             PayrollSupplementDeletePackWithHttpInfo(id, packid);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> PayrollSupplementDeletePackWithHttpInfo (string id, string packid)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDeletePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementDeletePack");

            var localVarPath = "/hr/payroll_supplement/id/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDeletePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task PayrollSupplementDeletePackAsync (string id, string packid)
        {
             await PayrollSupplementDeletePackAsyncWithHttpInfo(id, packid);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> PayrollSupplementDeletePackAsyncWithHttpInfo (string id, string packid)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementDeletePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementDeletePack");

            var localVarPath = "/hr/payroll_supplement/id/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementDeletePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement PayrollSupplementExternalId (string source, string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = PayrollSupplementExternalIdWithHttpInfo(source, id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > PayrollSupplementExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->PayrollSupplementExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementExternalId");

            var localVarPath = "/hr/payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementExternalIdAsync (string source, string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await PayrollSupplementExternalIdAsyncWithHttpInfo(source, id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->PayrollSupplementExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementExternalId");

            var localVarPath = "/hr/payroll_supplement/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement PayrollSupplementId (string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = PayrollSupplementIdWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > PayrollSupplementIdWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementId");

            var localVarPath = "/hr/payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementIdAsync (string id)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await PayrollSupplementIdAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementIdAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementId");

            var localVarPath = "/hr/payroll_supplement/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>PayrollSupplementListContainer</returns>
        public PayrollSupplementListContainer PayrollSupplementList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<PayrollSupplementListContainer> localVarResponse = PayrollSupplementListWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of PayrollSupplementListContainer</returns>
        public ApiResponse< PayrollSupplementListContainer > PayrollSupplementListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplementListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplementListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplementListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of PayrollSupplementListContainer</returns>
        public async System.Threading.Tasks.Task<PayrollSupplementListContainer> PayrollSupplementListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<PayrollSupplementListContainer> localVarResponse = await PayrollSupplementListAsyncWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (PayrollSupplementListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplementListContainer>> PayrollSupplementListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/payroll_supplement";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplementListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplementListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplementListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>PayrollSupplementTypeListContainer</returns>
        public PayrollSupplementTypeListContainer PayrollSupplementTypeList ()
        {
             ApiResponse<PayrollSupplementTypeListContainer> localVarResponse = PayrollSupplementTypeListWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of PayrollSupplementTypeListContainer</returns>
        public ApiResponse< PayrollSupplementTypeListContainer > PayrollSupplementTypeListWithHttpInfo ()
        {

            var localVarPath = "/hr/payroll_supplement/payroll_supplement_type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);



            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementTypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplementTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplementTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplementTypeListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of PayrollSupplementTypeListContainer</returns>
        public async System.Threading.Tasks.Task<PayrollSupplementTypeListContainer> PayrollSupplementTypeListAsync ()
        {
             ApiResponse<PayrollSupplementTypeListContainer> localVarResponse = await PayrollSupplementTypeListAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (PayrollSupplementTypeListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplementTypeListContainer>> PayrollSupplementTypeListAsyncWithHttpInfo ()
        {

            var localVarPath = "/hr/payroll_supplement/payroll_supplement_type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);



            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementTypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplementTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplementTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplementTypeListContainer)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement PayrollSupplementUpdate (string id, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = PayrollSupplementUpdateWithHttpInfo(id, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > PayrollSupplementUpdateWithHttpInfo (string id, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementUpdate");

            var localVarPath = "/hr/payroll_supplement/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementUpdateAsync (string id, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await PayrollSupplementUpdateAsyncWithHttpInfo(id, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementUpdateAsyncWithHttpInfo (string id, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementUpdate");

            var localVarPath = "/hr/payroll_supplement/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>PayrollSupplement</returns>
        public PayrollSupplement PayrollSupplementUpdatePack (string id, string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = PayrollSupplementUpdatePackWithHttpInfo(id, packid, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of PayrollSupplement</returns>
        public ApiResponse< PayrollSupplement > PayrollSupplementUpdatePackWithHttpInfo (string id, string packid, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementUpdatePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementUpdatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementUpdatePack");

            var localVarPath = "/hr/payroll_supplement/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementUpdatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of PayrollSupplement</returns>
        public async System.Threading.Tasks.Task<PayrollSupplement> PayrollSupplementUpdatePackAsync (string id, string packid, PayrollSupplement body)
        {
             ApiResponse<PayrollSupplement> localVarResponse = await PayrollSupplementUpdatePackAsyncWithHttpInfo(id, packid, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (PayrollSupplement)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<PayrollSupplement>> PayrollSupplementUpdatePackAsyncWithHttpInfo (string id, string packid, PayrollSupplement body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->PayrollSupplementUpdatePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->PayrollSupplementUpdatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->PayrollSupplementUpdatePack");

            var localVarPath = "/hr/payroll_supplement/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("PayrollSupplementUpdatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<PayrollSupplement>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (PayrollSupplement) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(PayrollSupplement)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>TimeAttendance</returns>
        public TimeAttendance TimeAttendanceId (string id)
        {
             ApiResponse<TimeAttendance> localVarResponse = TimeAttendanceIdWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeAttendance</returns>
        public ApiResponse< TimeAttendance > TimeAttendanceIdWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeAttendanceId");

            var localVarPath = "/hr/time_attendance/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeAttendanceId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeAttendance>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeAttendance) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeAttendance)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of TimeAttendance</returns>
        public async System.Threading.Tasks.Task<TimeAttendance> TimeAttendanceIdAsync (string id)
        {
             ApiResponse<TimeAttendance> localVarResponse = await TimeAttendanceIdAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeAttendance)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeAttendance>> TimeAttendanceIdAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeAttendanceId");

            var localVarPath = "/hr/time_attendance/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeAttendanceId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeAttendance>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeAttendance) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeAttendance)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>TimeAttendanceListContainer</returns>
        public TimeAttendanceListContainer TimeAttendanceList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<TimeAttendanceListContainer> localVarResponse = TimeAttendanceListWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of TimeAttendanceListContainer</returns>
        public ApiResponse< TimeAttendanceListContainer > TimeAttendanceListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/time_attendance";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeAttendanceList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeAttendanceListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeAttendanceListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeAttendanceListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of TimeAttendanceListContainer</returns>
        public async System.Threading.Tasks.Task<TimeAttendanceListContainer> TimeAttendanceListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<TimeAttendanceListContainer> localVarResponse = await TimeAttendanceListAsyncWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (TimeAttendanceListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeAttendanceListContainer>> TimeAttendanceListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/time_attendance";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeAttendanceList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeAttendanceListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeAttendanceListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeAttendanceListContainer)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        public TimeExtra TimeExtraCreate (TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = TimeExtraCreateWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        public ApiResponse< TimeExtra > TimeExtraCreateWithHttpInfo (TimeExtra body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraCreate");

            var localVarPath = "/hr/time_extra";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        public async System.Threading.Tasks.Task<TimeExtra> TimeExtraCreateAsync (TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = await TimeExtraCreateAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraCreateAsyncWithHttpInfo (TimeExtra body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraCreate");

            var localVarPath = "/hr/time_extra";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        public TimeExtra TimeExtraCreatePack (string packid, TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = TimeExtraCreatePackWithHttpInfo(packid, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        public ApiResponse< TimeExtra > TimeExtraCreatePackWithHttpInfo (string packid, TimeExtra body)
        {
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraCreatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraCreatePack");

            var localVarPath = "/hr/time_extra/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraCreatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        public async System.Threading.Tasks.Task<TimeExtra> TimeExtraCreatePackAsync (string packid, TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = await TimeExtraCreatePackAsyncWithHttpInfo(packid, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraCreatePackAsyncWithHttpInfo (string packid, TimeExtra body)
        {
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraCreatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraCreatePack");

            var localVarPath = "/hr/time_extra/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraCreatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        public void TimeExtraDelete (string id)
        {
             TimeExtraDeleteWithHttpInfo(id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> TimeExtraDeleteWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDelete");

            var localVarPath = "/hr/time_extra/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task TimeExtraDeleteAsync (string id)
        {
             await TimeExtraDeleteAsyncWithHttpInfo(id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeleteAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDelete");

            var localVarPath = "/hr/time_extra/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        public void TimeExtraDeleteExternalId (string source, string id)
        {
             TimeExtraDeleteExternalIdWithHttpInfo(source, id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> TimeExtraDeleteExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeExtraDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDeleteExternalId");

            var localVarPath = "/hr/time_extra/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task TimeExtraDeleteExternalIdAsync (string source, string id)
        {
             await TimeExtraDeleteExternalIdAsyncWithHttpInfo(source, id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeleteExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeExtraDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDeleteExternalId");

            var localVarPath = "/hr/time_extra/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        public void TimeExtraDeleteExternalIdPack (string source, string id, string packid)
        {
             TimeExtraDeleteExternalIdPackWithHttpInfo(source, id, packid);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> TimeExtraDeleteExternalIdPackWithHttpInfo (string source, string id, string packid)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeExtraDeleteExternalIdPack");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDeleteExternalIdPack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraDeleteExternalIdPack");

            var localVarPath = "/hr/time_extra/external/{source}/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDeleteExternalIdPack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task TimeExtraDeleteExternalIdPackAsync (string source, string id, string packid)
        {
             await TimeExtraDeleteExternalIdPackAsyncWithHttpInfo(source, id, packid);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeleteExternalIdPackAsyncWithHttpInfo (string source, string id, string packid)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeExtraDeleteExternalIdPack");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDeleteExternalIdPack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraDeleteExternalIdPack");

            var localVarPath = "/hr/time_extra/external/{source}/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDeleteExternalIdPack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns></returns>
        public void TimeExtraDeletePack (string id, string packid)
        {
             TimeExtraDeletePackWithHttpInfo(id, packid);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> TimeExtraDeletePackWithHttpInfo (string id, string packid)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDeletePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraDeletePack");

            var localVarPath = "/hr/time_extra/id/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDeletePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task TimeExtraDeletePackAsync (string id, string packid)
        {
             await TimeExtraDeletePackAsyncWithHttpInfo(id, packid);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> TimeExtraDeletePackAsyncWithHttpInfo (string id, string packid)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraDeletePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraDeletePack");

            var localVarPath = "/hr/time_extra/id/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraDeletePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>TimeExtra</returns>
        public TimeExtra TimeExtraExternalId (string source, string id)
        {
             ApiResponse<TimeExtra> localVarResponse = TimeExtraExternalIdWithHttpInfo(source, id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        public ApiResponse< TimeExtra > TimeExtraExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeExtraExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraExternalId");

            var localVarPath = "/hr/time_extra/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of TimeExtra</returns>
        public async System.Threading.Tasks.Task<TimeExtra> TimeExtraExternalIdAsync (string source, string id)
        {
             ApiResponse<TimeExtra> localVarResponse = await TimeExtraExternalIdAsyncWithHttpInfo(source, id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeExtraExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraExternalId");

            var localVarPath = "/hr/time_extra/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>TimeExtra</returns>
        public TimeExtra TimeExtraId (string id)
        {
             ApiResponse<TimeExtra> localVarResponse = TimeExtraIdWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        public ApiResponse< TimeExtra > TimeExtraIdWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraId");

            var localVarPath = "/hr/time_extra/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of TimeExtra</returns>
        public async System.Threading.Tasks.Task<TimeExtra> TimeExtraIdAsync (string id)
        {
             ApiResponse<TimeExtra> localVarResponse = await TimeExtraIdAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraIdAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraId");

            var localVarPath = "/hr/time_extra/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>TimeExtraListContainer</returns>
        public TimeExtraListContainer TimeExtraList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<TimeExtraListContainer> localVarResponse = TimeExtraListWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>ApiResponse of TimeExtraListContainer</returns>
        public ApiResponse< TimeExtraListContainer > TimeExtraListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/time_extra";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtraListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtraListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtraListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of TimeExtraListContainer</returns>
        public async System.Threading.Tasks.Task<TimeExtraListContainer> TimeExtraListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {
             ApiResponse<TimeExtraListContainer> localVarResponse = await TimeExtraListAsyncWithHttpInfo(offset, limit, employee, type, startDate, endDate);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <returns>Task of ApiResponse (TimeExtraListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtraListContainer>> TimeExtraListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null)
        {

            var localVarPath = "/hr/time_extra";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtraListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtraListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtraListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>TimeExtraTypeListContainer</returns>
        public TimeExtraTypeListContainer TimeExtraTypeList ()
        {
             ApiResponse<TimeExtraTypeListContainer> localVarResponse = TimeExtraTypeListWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of TimeExtraTypeListContainer</returns>
        public ApiResponse< TimeExtraTypeListContainer > TimeExtraTypeListWithHttpInfo ()
        {

            var localVarPath = "/hr/time_extra/time_extra_type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);



            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraTypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtraTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtraTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtraTypeListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of TimeExtraTypeListContainer</returns>
        public async System.Threading.Tasks.Task<TimeExtraTypeListContainer> TimeExtraTypeListAsync ()
        {
             ApiResponse<TimeExtraTypeListContainer> localVarResponse = await TimeExtraTypeListAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (TimeExtraTypeListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtraTypeListContainer>> TimeExtraTypeListAsyncWithHttpInfo ()
        {

            var localVarPath = "/hr/time_extra/time_extra_type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);



            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraTypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtraTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtraTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtraTypeListContainer)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        public TimeExtra TimeExtraUpdate (string id, TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = TimeExtraUpdateWithHttpInfo(id, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        public ApiResponse< TimeExtra > TimeExtraUpdateWithHttpInfo (string id, TimeExtra body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraUpdate");

            var localVarPath = "/hr/time_extra/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        public async System.Threading.Tasks.Task<TimeExtra> TimeExtraUpdateAsync (string id, TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = await TimeExtraUpdateAsyncWithHttpInfo(id, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraUpdateAsyncWithHttpInfo (string id, TimeExtra body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraUpdate");

            var localVarPath = "/hr/time_extra/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>TimeExtra</returns>
        public TimeExtra TimeExtraUpdatePack (string id, string packid, TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = TimeExtraUpdatePackWithHttpInfo(id, packid, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeExtra</returns>
        public ApiResponse< TimeExtra > TimeExtraUpdatePackWithHttpInfo (string id, string packid, TimeExtra body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraUpdatePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraUpdatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraUpdatePack");

            var localVarPath = "/hr/time_extra/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraUpdatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeExtra</returns>
        public async System.Threading.Tasks.Task<TimeExtra> TimeExtraUpdatePackAsync (string id, string packid, TimeExtra body)
        {
             ApiResponse<TimeExtra> localVarResponse = await TimeExtraUpdatePackAsyncWithHttpInfo(id, packid, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="packid"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeExtra)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeExtra>> TimeExtraUpdatePackAsyncWithHttpInfo (string id, string packid, TimeExtra body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeExtraUpdatePack");
            // verify the required parameter 'packid' is set
            if (packid == null)
                throw new ApiException(400, "Missing required parameter 'packid' when calling HrApi->TimeExtraUpdatePack");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeExtraUpdatePack");

            var localVarPath = "/hr/time_extra/{id}/pack/{packid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (packid != null) localVarPathParams.Add("packid", this.Configuration.ApiClient.ParameterToString(packid)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeExtraUpdatePack", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeExtra>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeExtra) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeExtra)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>TimeOffLeave</returns>
        public TimeOffLeave TimeOffLeaveCreate (TimeOffLeave body)
        {
             ApiResponse<TimeOffLeave> localVarResponse = TimeOffLeaveCreateWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        public ApiResponse< TimeOffLeave > TimeOffLeaveCreateWithHttpInfo (TimeOffLeave body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeOffLeaveCreate");

            var localVarPath = "/hr/time_off_leave";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of TimeOffLeave</returns>
        public async System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveCreateAsync (TimeOffLeave body)
        {
             ApiResponse<TimeOffLeave> localVarResponse = await TimeOffLeaveCreateAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveCreateAsyncWithHttpInfo (TimeOffLeave body)
        {
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeOffLeaveCreate");

            var localVarPath = "/hr/time_off_leave";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveCreate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns></returns>
        public void TimeOffLeaveDelete (string id)
        {
             TimeOffLeaveDeleteWithHttpInfo(id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> TimeOffLeaveDeleteWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveDelete");

            var localVarPath = "/hr/time_off_leave/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task TimeOffLeaveDeleteAsync (string id)
        {
             await TimeOffLeaveDeleteAsyncWithHttpInfo(id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> TimeOffLeaveDeleteAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveDelete");

            var localVarPath = "/hr/time_off_leave/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns></returns>
        public void TimeOffLeaveDeleteExternalId (string source, string id)
        {
             TimeOffLeaveDeleteExternalIdWithHttpInfo(source, id);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of Object(void)</returns>
        public ApiResponse<Object> TimeOffLeaveDeleteExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeOffLeaveDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveDeleteExternalId");

            var localVarPath = "/hr/time_off_leave/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task TimeOffLeaveDeleteExternalIdAsync (string source, string id)
        {
             await TimeOffLeaveDeleteExternalIdAsyncWithHttpInfo(source, id);

        }

        /// <summary>
        /// Delete record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<ApiResponse<Object>> TimeOffLeaveDeleteExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeOffLeaveDeleteExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveDeleteExternalId");

            var localVarPath = "/hr/time_off_leave/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveDeleteExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<Object>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                null);
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>TimeOffLeave</returns>
        public TimeOffLeave TimeOffLeaveExternalId (string source, string id)
        {
             ApiResponse<TimeOffLeave> localVarResponse = TimeOffLeaveExternalIdWithHttpInfo(source, id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        public ApiResponse< TimeOffLeave > TimeOffLeaveExternalIdWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeOffLeaveExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveExternalId");

            var localVarPath = "/hr/time_off_leave/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of TimeOffLeave</returns>
        public async System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveExternalIdAsync (string source, string id)
        {
             ApiResponse<TimeOffLeave> localVarResponse = await TimeOffLeaveExternalIdAsyncWithHttpInfo(source, id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="source"></param>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveExternalIdAsyncWithHttpInfo (string source, string id)
        {
            // verify the required parameter 'source' is set
            if (source == null)
                throw new ApiException(400, "Missing required parameter 'source' when calling HrApi->TimeOffLeaveExternalId");
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveExternalId");

            var localVarPath = "/hr/time_off_leave/external/{source}/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (source != null) localVarPathParams.Add("source", this.Configuration.ApiClient.ParameterToString(source)); // path parameter
            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveExternalId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>TimeOffLeave</returns>
        public TimeOffLeave TimeOffLeaveId (string id)
        {
             ApiResponse<TimeOffLeave> localVarResponse = TimeOffLeaveIdWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        public ApiResponse< TimeOffLeave > TimeOffLeaveIdWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveId");

            var localVarPath = "/hr/time_off_leave/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of TimeOffLeave</returns>
        public async System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveIdAsync (string id)
        {
             ApiResponse<TimeOffLeave> localVarResponse = await TimeOffLeaveIdAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveIdAsyncWithHttpInfo (string id)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveId");

            var localVarPath = "/hr/time_off_leave/id/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveId", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>TimeOffLeaveListContainer</returns>
        public TimeOffLeaveListContainer TimeOffLeaveList (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null)
        {
             ApiResponse<TimeOffLeaveListContainer> localVarResponse = TimeOffLeaveListWithHttpInfo(offset, limit, employee, type, startDate, endDate, approved);
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>ApiResponse of TimeOffLeaveListContainer</returns>
        public ApiResponse< TimeOffLeaveListContainer > TimeOffLeaveListWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null)
        {

            var localVarPath = "/hr/time_off_leave";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter
            if (approved != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "approved", approved)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeaveListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeaveListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeaveListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>Task of TimeOffLeaveListContainer</returns>
        public async System.Threading.Tasks.Task<TimeOffLeaveListContainer> TimeOffLeaveListAsync (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null)
        {
             ApiResponse<TimeOffLeaveListContainer> localVarResponse = await TimeOffLeaveListAsyncWithHttpInfo(offset, limit, employee, type, startDate, endDate, approved);
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="offset"> (optional, default to 0)</param>
        /// <param name="limit"> (optional, default to 100)</param>
        /// <param name="employee"> (optional)</param>
        /// <param name="type"> (optional)</param>
        /// <param name="startDate">ISO 8601 (optional)</param>
        /// <param name="endDate">ISO 8601 (optional)</param>
        /// <param name="approved"> (optional)</param>
        /// <returns>Task of ApiResponse (TimeOffLeaveListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeOffLeaveListContainer>> TimeOffLeaveListAsyncWithHttpInfo (int? offset = null, int? limit = null, string employee = null, string type = null, DateTime? startDate = null, DateTime? endDate = null, bool? approved = null)
        {

            var localVarPath = "/hr/time_off_leave";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (offset != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "offset", offset)); // query parameter
            if (limit != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "limit", limit)); // query parameter
            if (employee != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "employee", employee)); // query parameter
            if (type != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "type", type)); // query parameter
            if (startDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "startDate", startDate)); // query parameter
            if (endDate != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "endDate", endDate)); // query parameter
            if (approved != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "approved", approved)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeaveListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeaveListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeaveListContainer)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>TimeOffLeave</returns>
        public TimeOffLeave TimeOffLeaveUpdate (string id, TimeOffLeave body)
        {
             ApiResponse<TimeOffLeave> localVarResponse = TimeOffLeaveUpdateWithHttpInfo(id, body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>ApiResponse of TimeOffLeave</returns>
        public ApiResponse< TimeOffLeave > TimeOffLeaveUpdateWithHttpInfo (string id, TimeOffLeave body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeOffLeaveUpdate");

            var localVarPath = "/hr/time_off_leave/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of TimeOffLeave</returns>
        public async System.Threading.Tasks.Task<TimeOffLeave> TimeOffLeaveUpdateAsync (string id, TimeOffLeave body)
        {
             ApiResponse<TimeOffLeave> localVarResponse = await TimeOffLeaveUpdateAsyncWithHttpInfo(id, body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update record 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id"></param>
        /// <param name="body"></param>
        /// <returns>Task of ApiResponse (TimeOffLeave)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeOffLeave>> TimeOffLeaveUpdateAsyncWithHttpInfo (string id, TimeOffLeave body)
        {
            // verify the required parameter 'id' is set
            if (id == null)
                throw new ApiException(400, "Missing required parameter 'id' when calling HrApi->TimeOffLeaveUpdate");
            // verify the required parameter 'body' is set
            if (body == null)
                throw new ApiException(400, "Missing required parameter 'body' when calling HrApi->TimeOffLeaveUpdate");

            var localVarPath = "/hr/time_off_leave/{id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarPathParams.Add("id", this.Configuration.ApiClient.ParameterToString(id)); // path parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeaveUpdate", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeave>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeave) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeave)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>TimeOffLeaveTypeListContainer</returns>
        public TimeOffLeaveTypeListContainer TimeOffLeavetypeList ()
        {
             ApiResponse<TimeOffLeaveTypeListContainer> localVarResponse = TimeOffLeavetypeListWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of TimeOffLeaveTypeListContainer</returns>
        public ApiResponse< TimeOffLeaveTypeListContainer > TimeOffLeavetypeListWithHttpInfo ()
        {

            var localVarPath = "/hr/time_off_leave/time_off_leave_type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);



            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeavetypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeaveTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeaveTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeaveTypeListContainer)));
        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of TimeOffLeaveTypeListContainer</returns>
        public async System.Threading.Tasks.Task<TimeOffLeaveTypeListContainer> TimeOffLeavetypeListAsync ()
        {
             ApiResponse<TimeOffLeaveTypeListContainer> localVarResponse = await TimeOffLeavetypeListAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// List records 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (TimeOffLeaveTypeListContainer)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TimeOffLeaveTypeListContainer>> TimeOffLeavetypeListAsyncWithHttpInfo ()
        {

            var localVarPath = "/hr/time_off_leave/time_off_leave_type";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);



            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("TimeOffLeavetypeList", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TimeOffLeaveTypeListContainer>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TimeOffLeaveTypeListContainer) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(TimeOffLeaveTypeListContainer)));
        }

    }
}
